900 'Program take-off angle,Author:Henrik Kaker,May-23,1987
950 KEY OFF
951 OPEN"I",#1,"color.dat"
952 INPUT #1,X99
953 INPUT #1,Y99
954 INPUT #1,Z99
955 COLOR X99,Y99,Z99
960 CLS
1000 T$="TAKE-OFF ANGLE vs. TILT ANGLE"
1010 LOCATE 4,(80-LEN(T$))/2
1020 PRINT T$
1050 LOCATE 5,27
1060 PRINT"Use degrees & millimeters."
1100 LOCATE 8,23:INPUT"     Working distance W: ",W
1110 LOCATE 9,23:INPUT"Intersection distance D: ",D
1120 LOCATE 10,29:INPUT"Elevation angle I: ",I
1130 LOCATE 11,31:INPUT"Azimuth angle A: ",A
1140 LOCATE 12,31:INPUT"Detector area B: ",B
1146 LOCATE 13,29:INPUT"Min tilt angle M1: ",M1
1148 LOCATE 14,29:INPUT"Max tilt angle M2: ",M2
1149 LOCATE 15,30:INPUT"Tilt increment X: ",X
1150 LOCATE 16,26:INPUT"Min scale setting S1: ",S1
1155 LOCATE 17,26:INPUT"Max scale setting S2: ",S2
1159 CLS
1160 LOCATE 2,6:PRINT"Take-off angle T as function of specimen tilt angle"
1180 PRINT
1185 T=(S2-S1)/3
1187 T=CINT(T)
1190 PRINT" M"," S=";S1," S=";S1+T," S=";S1+2*T," S=";S2
1200 PRINT
1210 FOR M=M1 TO M2 STEP X
1220 PRINT M;
1230 FOR S=S1 TO S2 STEP (S2-S1)/3
1240 GOSUB 5000
1250 PRINT,INT(T*10^2+.5)/10^2;
1260 NEXT S
1270 PRINT
1271 IF M=15 THEN GOSUB 2000
1272 IF M=30 THEN GOSUB 2000
1273 IF M=45 THEN GOSUB 2000
1274 IF M=60 THEN GOSUB 2000
1275 IF M=75 THEN GOSUB 2000
1280 NEXT M
1285 PRINT:PRINT
1290 PRINT TAB(18);
1291 INPUT"Another calculation (y/n): ",ZZ$
1292 IF ZZ$="Y" OR ZZ$="y" GOTO 960
1294 IF ZZ$="N" OR ZZ$="n" GOTO 1300
1300 CLOSE:CLS
1310 OPEN"i",#5,"menu.dat"
1320 INPUT #5,XY999
1330 IF XY999=1 GOTO 1350
1340 IF XY999=0 GOTO 1360
1350 CLOSE:RUN"ms.exe":END
1360 CLOSE:SYSTEM:END
2000 'Scrolling routine
2010 A$=INKEY$:IF A$="" GOTO 2010
2020 RETURN
5000 REM Subroutine to calculate T=take off angle of X-rays
5100 DEF FNR(A)=A/57.2958
5110 DEF FNA(R)=R*57.2958
5120 L=FNR(90+I)
5130 Z=W-D
5140 R=SQR(S*S+Z*Z-2*S*Z*COS(L))
5150 Y=S*SIN(L)/R
5160 E=90-FNA(ATN(Y/SQR(1-Y*Y)))
5170 X=E-I
5180 Q=COS(FNR(X))*(B/(R*R)+1-SQR(R*R+B/6.28318)/R)
5190 K=FNR(M)
5200 T=E+FNA(ATN(SIN(K)*COS(FNR(A))/COS(K)))
5210 RETURN
