300 'Bence-Albee program for 15 kV - 38.5 degrees,Author:H.Kaker,22-10-88
305 CLEAR
310 KEY OFF
320 OPEN"i",#1,"color.dat"
330 INPUT #1,X999
340 INPUT #1,Y999
350 INPUT #1,Z999
360 COLOR X999,Y999,Z999
370 CLS
380 DIM A(36,36),Z$(15),Z(15),A5(15),BCU(15),A6(15),BCS(15),W1(15),B1(15)
390 DIM K0(15),K(15),B(36,36),CC$(15)
430 T$="BENCE-ALBEE CORRECTION PROGRAM"
440 LOCATE 5,(80-LEN(T$))/2
450 PRINT T$
460 LOCATE 10,30:INPUT"Number of elements: ",AA
470 LOCATE 12,22:INPUT"Pure oxide standards (y/n): ",XX$
475 CLS
480 LOCATE 3,6:PRINT"Element";TAB(19)"Int.for sample";TAB(39)"BCF";TAB(47)"Int.for standard";TAB(68)"BCF"
490 FOR I=1 TO AA
500 LOCATE (4+I),8:INPUT"",Z$(I)
501 IF Z$(I)="O" OR Z$(I)="o" THEN Z(I)=1
502 IF Z$(I)="C" OR Z$(I)="c" THEN Z(I)=2
503 IF Z$(I)="F" OR Z$(I)="f" THEN Z(I)=3
504 IF Z$(I)="Na" OR Z$(I)="na" OR Z$(I)="NA" THEN Z(I)=4
505 IF Z$(I)="Al" OR Z$(I)="al" OR Z$(I)="AL" THEN Z(I)=6
506 IF Z$(I)="Mg" OR Z$(I)="mg" OR Z$(I)="MG" THEN Z(I)=5
507 IF Z$(I)="Si"OR Z$(I)="si" OR Z$(I)="SI" THEN Z(I)=7
508 IF Z$(I)="P" OR Z$(I)="p" THEN Z(I)=8
509 IF Z$(I)="S" OR Z$(I)="s" THEN Z(I)=9
510 IF Z$(I)="Cl" OR Z$(I)="cl" OR Z$(I)="CL" THEN Z(I)=10
511 IF Z$(I)="K" OR Z$(I)="k" THEN Z(I)=11
512 IF Z$(I)="Ca" OR Z$(I)="ca" OR Z$(I)="CA" THEN Z(I)=12
513 IF Z$(I)="Ti" OR Z$(I)="ti" OR Z$(I)="TI" THEN Z(I)=13
514 IF Z$(I)="Cr" OR Z$(I)="cr" OR Z$(I)="CR" THEN Z(I)=14
515 IF Z$(I)="Mn" OR Z$(I)="mn" OR Z$(I)="MN" THEN Z(I)=15
516 IF Z$(I)="Fe" OR Z$(I)="fe" OR Z$(I)="FE" THEN Z(I)=16
517 IF Z$(I)="Co" OR Z$(I)="co" OR Z$(I)="CO" THEN Z(I)=17
518 IF Z$(I)="Ni" OR Z$(I)="ni" OR Z$(I)="NI" THEN Z(I)=18
519 IF Z$(I)="Cu" OR Z$(I)="cu" OR Z$(I)="CU" THEN Z(I)=19
520 IF Z$(I)="Zn" OR Z$(I)="zn" OR Z$(I)="ZN" THEN Z(I)=20
521 IF Z$(I)="Rb" OR Z$(I)="rb" OR Z$(I)="RB" THEN Z(I)=21
522 IF Z$(I)="Sr" OR Z$(I)="sr" OR Z$(I)="SR" THEN Z(I)=22
523 IF Z$(I)="Y" OR Z$(I)="y" THEN Z(I)=23
524 IF Z$(I)="Zr" OR Z$(I)="zr" OR Z$(I)="ZR" THEN Z(I)=24
525 IF Z$(I)="La" OR Z$(I)="la" OR Z$(I)="LA" THEN Z(I)=26
526 IF Z$(I)="Ce" OR Z$(I)="ce" OR Z$(I)="CE" THEN Z(I)=27
527 IF Z$(I)="Pr" OR Z$(I)="pr" OR Z$(I)="PR" THEN Z(I)=28
528 IF Z$(I)="Nd" OR Z$(I)="nd" OR Z$(I)="ND" THEN Z(I)=29
529 IF Z$(I)="Sm" OR Z$(I)="sm" OR Z$(I)="SM" THEN Z(I)=30
530 IF Z$(I)="Gd" OR Z$(I)="gd" OR Z$(I)="GD" THEN Z(I)=31
531 IF Z$(I)="Dy" OR Z$(I)="dy" OR Z$(I)="DY" THEN Z(I)=32
532 IF Z$(I)="Er" OR Z$(I)="er" OR Z$(I)="ER" THEN Z(I)=33
533 IF Z$(I)="Hf" OR Z$(I)="hf" OR Z$(I)="HF" THEN Z(I)=34
534 IF Z$(I)="Th" OR Z$(I)="th" OR Z$(I)="TH" THEN Z(I)=35
535 IF Z$(I)="U" OR Z$(I)="u" THEN Z(I)=36
536 IF Z$(I)="Ba" OR Z$(I)="ba" OR Z$(I)="BA" THEN Z(I)=25
540 LOCATE (4+I),21:INPUT"",A5(I)
550 LOCATE (4+I),39:INPUT"",BCU(I)
560 LOCATE (4+I),49:INPUT"",A6(I)
570 LOCATE (4+I),68:INPUT"",BCS(I)
580 NEXT I
590 IF XX$="N" OR XX$="n" THEN 600 ELSE 700
600 CLS
610 T$="Input data for mixed (not pure oxid) standards."
620 LOCATE 3,(80-LEN(T$))/2
630 PRINT T$
640 LOCATE 5,14:PRINT"Element";TAB(34)"Weight percent";TAB(60)"Beta"
650 FOR I=1 TO AA
660 LOCATE (6+I),17:PRINT Z$(I)
670 LOCATE (6+I),37:INPUT"",W1(I):W1(I)=W1(I)/100
680 LOCATE (6+I),60:INPUT"",B1(I)
690 NEXT I
700 'Calc.after method Bence-Albee
710 'First aproximation
720 IF XX$="y" OR XX$="Y" THEN 725 ELSE 800
725 S=0
730 FOR I=1 TO AA
740 A5(I)=A5(I)*(1/BCU(I))
750 A6(I)=A6(I)*(1/BCS(I))
760 K0(I)=A5(I)/A6(I)
770 S=S+K0(I)
780 NEXT I
785 GOTO 900
790 'Calc.
800 S=0
810 FOR I=1 TO AA
820 A5(I)=A5(I)*(1/BCU(I))
830 A6(I)=A6(I)*(1/BCS(I))
840 K0(I)=A5(I)/A6(I)*W1(I)/B1(I)
850 S=S+K0(I)
860 NEXT I
900 'Sample composition
1000 'Alfa matrix for 15 kV-38.5 deg.
1020 DATA 1.00,1.94,1.07,1.50,1.83,2.02,2.26,2.57,2.87,7.43,9.83,10.43,12.19,1.85,2.11,2.32,2.51,2.82,3.06,3.39,7.20,7.94,8.26,8.97,3.02,3.04,3.16,3.28,3.38,3.58,3.85,4.07,4.29,4.99,9.72,10.63
1021 DATA 1.16,1.00,1.49,3.14,4.42,5.66,6.64,8.83,10.16,38.79,3.60,3.43,3.49,4.77,6.04,7.04,8.14,9.62,11.29,13.30,26.88,22.18,17.83,19.93,8.69,8.31,8.77,9.26,9.72,10.67,11.94,12.99,14.07,18.29,44.22,49.71
1022 DATA 7.14,6.51,1.00,2.63,3.70,4.45,5.02,5.61,6.04,3.89,6.06,7.23,9.30,14.41,12.82,2.70,2.74,2.93,2.95,3.10,4.29,5.03,5.55,6.23,2.48,2.67,2.74,2.81,2.84,2.92,3.03,3.12,3.23,3.72,6.10,6.54
1023 DATA 1.81,1.62,2.08,1.00,1.21,1.30,1.42,1.48,1.56,1.24,1.59,1.79,2.03,2.42,2.72,3.02,3.33,3.72,3.48,2.82,1.28,1.42,1.49,1.62,2.21,2.23,2.40,2.51,2.61,1.05,1.07,1.09,1.12,1.24,1.85,1.96
1024 DATA 1.36,1.23,1.50,2.05,1.00,1.04,1.11,1.14,1.19,0.99,1.20,1.32,1.43,1.64,1.80,1.97,2.12,2.34,2.50,2.72,0.97,1.05,1.10,1.17,1.95,1.97,1.77,1.84,1.69,1.80,1.92,0.86,0.87,0.94,1.31,1.38
1025 DATA 1.20,1.11,1.28,1.63,1.76,1.00,1.05,1.06,1.10,0.95,1.09,1.18,1.24,1.37,1.48,1.58,1.68,1.83,1.92,2.07,0.90,0.97,1.0,1.06,1.82,1.79,1.87,1.74,1.80,1.66,1.57,1.66,1.76,0.89,1.21,1.26
1026 DATA 1.10,1.04,1.15,1.38,1.48,1.54,1.00,1.00,1.03,0.91,1.01,1.07,1.10,1.18,1.24,1.31,1.37,1.47,1.51,1.60,0.84,0.88,0.91,0.95,1.39,1.39,1.44,1.49,1.53,1.61,1.52,1.41,1.34,1.54,1.02,1.06
1027 DATA 1.07,1.02,1.09,1.26,1.33,1.36,1.42,1.00,1.02,0.91,0.99,1.04,1.05,1.10,1.14,1.19,1.23,1.30,1.32,1.39,1.77,1.86,0.90,0.93,1.25,1.24,1.28,1.32,1.34,1.40,1.46,1.39,1.46,1.35,1.00,1.02
1028 DATA 1.04,1.00,1.04,1.16,1.22,1.24,1.28,1.31,1.00,0.90,0.95,1.00,0.99,1.02,1.04,1.08,1.10,1.15,1.16,1.20,1.55,1.63,1.49,1.56,1.06,1.06,1.08,1.11,1.13,1.16,1.19,1.23,1.28,1.19,0.89,0.91
1029 DATA 1.11,1.07,1.09,1.20,1.24,1.25,1.29,1.31,1.34,1.00,1.01,1.06,1.04,1.06,1.05,1.09,1.09,1.14,1.13,1.15,1.37,1.42,1.45,1.50,1.00,1.02,1.04,1.06,1.07,1.08,1.10,1.12,1.16,1.25,0.88,0.89
1030 DATA 1.06,1.04,1.03,1.10,1.13,1.12,1.15,1.15,1.17,1.33,1.00,0.99,0.97,0.97,0.96,0.98,0.97,1.01,0.99,1.00,1.09,1.13,1.14,1.18,0.87,0.88,0.89,0.90,0.91,0.91,0.91,0.92,0.94,0.99,0.82,0.82
1031 DATA 1.03,1.01,1.00,1.06,1.09,1.08,1.10,1.09,1.11,1.22,1.26,1.00,0.92,0.92,0.91,0.93,0.92,0.96,0.93,0.94,0.98,1.02,1.03,1.06,0.80,0.81,0.82,0.83,0.83,0.83,0.83,0.84,0.84,0.88,1.00,0.85
1032 DATA 1.08,1.06,1.05,1.09,1.12,1.10,1.12,1.11,1.12,1.15,1.19,1.21,1.00,0.90,0.89,0.92,0.91,0.95,0.92,0.93,0.94,0.97,0.99,1.01,0.83,0.82,0.82,0.78,0.79,0.79,0.79,0.79,0.80,0.82,0.95,0.97
1033 DATA 1.11,1.09,1.07,1.10,1.13,1.11,1.13,1.11,1.12,1.11,1.14,1.16,1.11,1.00,0.94,0.88,0.88,0.91,0.89,0.90,0.91,0.94,0.96,0.98,0.93,0.84,0.84,0.85,0.84,0.79,0.73,0.74,0.75,0.77,0.95,0.94
1034 DATA 1.14,1.13,1.10,1.14,1.16,1.14,1.16,1.14,1.16,1.13,1.15,1.17,1.12,1.03,1.00,0.98,0.86,0.90,0.89,0.90,0.92,0.94,0.97,0.98,0.95,0.96,0.93,0.86,0.85,0.84,0.78,0.78,0.73,0.76,0.91,0.92
1035 DATA 1.14,1.12,1.09,1.13,1.15,1.13,1.15,1.13,1.14,1.11,1.13,1.15,1.10,1.10,0.99,1.00,0.94,0.85,0.84,0.86,0.90,0.93,0.95,0.96,0.93,0.94,0.93,0.91,0.90,0.82,0.81,0.75,0.76,0.72,0.87,0.88
1036 DATA 1.16,1.14,1.12,1.15,1.18,1.15,1.17,1.15,1.16,1.12,1.14,1.16,1.11,1.10,1.08,1.02,1.00,0.98,0.81,0.84,0.91,0.94,0.96,0.97,0.92,0.94,0.94,0.95,0.92,0.88,0.82,0.81,0.75,0.69,0.86,0.87
1037 DATA 1.14,1.12,1.09,1.13,1.15,1.13,1.14,1.12,1.13,1.09,1.10,1.13,1.07,1.06,1.04,1.06,0.98,1.00,0.91,0.76,0.89,0.91,0.93,0.95,0.88,0.90,0.90,0.90,0.90,0.87,0.83,0.78,0.77,0.73,0.83,0.83
1038 DATA 1.19,1.17,1.14,1.18,1.20,1.18,1.19,1.17,1.18,1.13,1.14,1.17,1.11,1.10,1.07,1.09,1.07,1.04,1.00,0.93,0.92,0.94,0.97,0.98,0.90,0.92,0.92,0.92,0.92,0.90,0.87,0.85,0.80,0.73,0.85,0.85
1039 DATA 1.19,1.18,1.15,1.18,1.20,1.18,1.20,1.18,1.19,1.13,1.14,1.17,1.11,1.10,1.07,1.08,1.06,1.09,1.00,1.00,0.92,0.94,0.97,0.98,0.89,0.91,0.91,0.91,0.91,0.89,0.87,0.85,0.83,0.80,0.84,0.84
1040 DATA 1.42,1.35,1.43,1.66,1.76,1.83,1.29,1.27,1.31,1.16,1.26,1.34,1.35,1.43,1.46,1.54,1.59,1.70,1.73,1.82,1.00,1.04,1.10,1.14,1.60,1.66,1.71,1.78,1.82,1.74,1.82,1.69,1.62,1.15,1.20,1.24
1041 DATA 1.34,1.27,1.35,1.56,1.64,1.70,1.23,1.20,1.24,1.11,1.20,1.27,1.27,1.34,1.36,1.43,1.47,1.57,1.60,1.67,1.74,1.00,1.04,1.08,1.46,1.50,1.55,1.60,1.64,1.72,1.63,1.52,1.45,1.60,1.12,1.15
1042 DATA 1.28,1.23,1.28,1.45,1.53,1.56,1.62,1.17,1.20,1.07,1.15,1.21,1.20,1.25,1.27,1.33,1.36,1.45,1.46,1.53,1.93,0.96,1.00,1.03,1.35,1.38,1.42,1.47,1.50,1.57,1.63,1.56,1.46,1.47,1.07,1.10
1043 DATA 1.24,1.18,1.23,1.39,1.46,1.49,1.54,1.14,1.16,1.05,1.11,1.17,1.16,1.20,1.21,1.27,1.29,1.37,1.37,1.43,1.75,1.81,0.97,1.00,1.25,1.28,1.32,1.35,1.38,1.43,1.48,1.42,1.48,1.34,1.01,1.04
1044 DATA 1.45,1.40,1.39,1.42,1.46,1.42,1.45,1.41,1.45,1.45,1.48,1.51,1.28,1.21,1.18,1.20,1.18,1.22,1.18,1.18,1.14,1.17,1.21,1.23,1.00,1.03,1.01,1.02,1.01,0.98,0.97,0.97,0.97,0.99,1.12,1.14
1045 DATA 1.41,1.38,1.35,1.39,1.43,1.39,1.42,1.39,1.42,1.40,1.43,1.46,1.26,1.22,1.16,1.17,1.16,1.20,1.15,1.15,1.10,1.13,1.17,1.19,0.98,1.00,1.00,0.99,0.99,0.96,0.94,0.94,0.94,0.95,1.08,1.10
1046 DATA 1.41,1.38,1.35,1.39,1.43,1.39,1.42,1.38,1.41,1.39,1.41,1.45,1.26,1.22,1.15,1.17,1.15,1.19,1.14,1.15,1.09,1.12,1.16,1.18,0.97,1.00,1.00,1.01,1.00,0.96,0.93,0.93,0.93,0.94,1.10,1.08
1047 DATA 1.41,1.38,1.35,1.38,1.42,1.38,1.41,1.38,1.40,1.37,1.40,1.43,1.37,1.22,1.18,1.17,1.14,1.18,1.13,1.14,1.08,1.11,1.14,1.16,0.97,0.99,0.99,1.00,0.99,0.96,0.92,0.91,0.91,0.93,1.08,1.06
1048 DATA 1.43,1.40,1.37,1.40,1.44,1.40,1.43,1.40,1.42,1.38,1.40,1.44,1.37,1.24,1.20,1.18,1.15,1.19,1.14,1.15,1.09,1.12,1.15,1.17,0.98,1.00,1.00,1.01,1.00,0.98,0.95,0.92,0.91,0.92,1.10,1.09
1049 DATA 1.47,1.44,1.40,1.44,1.48,1.44,1.46,1.43,1.45,1.40,1.42,1.45,1.39,1.27,1.23,1.24,1.17,1.21,1.16,1.17,1.10,1.13,1.16,1.18,1.13,1.11,1.02,1.03,1.02,1.00,0.98,0.95,0.92,0.92,1.08,1.10
1050 DATA 1.51,1.48,1.44,1.48,1.52,1.48,1.50,1.47,1.49,1.43,1.44,1.48,1.41,1.40,1.27,1.29,1.25,1.24,1.18,1.19,1.12,1.15,1.18,1.20,1.15,1.15,1.12,1.13,1.04,1.02,1.00,0.96,0.96,0.94,1.07,1.09
1051 DATA 1.54,1.51,1.47,1.51,1.54,1.50,1.53,1.49,1.52,1.44,1.46,1.50,1.42,1.41,1.30,1.31,1.28,1.30,1.20,1.20,1.13,1.16,1.20,1.22,1.14,1.17,1.15,1.16,1.12,1.04,1.01,1.00,0.96,0.93,1.06,1.07
1052 DATA 1.56,1.53,1.49,1.53,1.57,1.52,1.55,1.51,1.54,1.46,1.47,1.51,1.43,1.41,1.38,1.33,1.30,1.34,1.26,1.20,1.15,1.17,1.21,1.23,1.13,1.16,1.17,1.17,1.15,1.10,1.03,1.01,1.00,0.97,1.06,1.06
1053 DATA 1.57,1.54,1.51,1.54,1.57,1.53,1.56,1.52,1.54,1.46,1.47,1.51,1.43,1.41,1.37,1.39,1.36,1.35,1.29,1.26,1.16,1.18,1.22,1.24,1.12,1.14,1.15,1.15,1.14,1.13,1.07,1.06,1.01,1.00,1.0,1.05
1054 DATA 1.62,1.55,1.55,1.59,1.66,1.60,1.66,1.61,1.67,1.83,1.41,1.48,1.39,1.35,1.34,1.37,1.35,1.41,1.35,1.37,1.42,1.46,1.51,1.54,1.12,1.15,1.17,1.19,1.19,1.19,1.19,1.21,1.23,1.28,1.00,1.01
1055 DATA 1.63,1.57,1.56,1.60,1.66,1.60,1.66,1.60,1.66,1.78,1.42,1.49,1.40,1.35,1.34,1.37,1.35,1.40,1.34,1.35,1.37,1.41,1.46,1.49,1.10,1.14,1.15,1.16,1.16,1.16,1.16,1.17,1.18,1.23,0.99,1.00
1060 FOR X=1 TO 36
1070 FOR Y=1 TO 36
1080 READ A(X,Y)
1090 NEXT Y
1100 NEXT X
1110 'Weight percent
1120 S1=0:B(I,J)=0
1130 FOR I=1 TO AA
1140 B=0
1150 FOR J=1 TO AA
1160 B(I,J)=K0(J)*A(Z(I),Z(J))
1170 B=B+B(I,J)
1180 NEXT J
1190 K(I)=K0(I)*(B/S)
1200 S1=S1+K(I)
1210 NEXT I
1220 'Iteration
1230 IF (S1-S)<.00001 THEN 1300 ELSE 1240
1240 IF S1>1 GOTO 1300 ELSE 1245
1245 S=0:S=S1
1250 FOR I=1 TO AA
1260 K0(I)=0
1270 K0(I)=K(I)
1280 NEXT I
1290 GOTO 1110
1300 'Screen
1305 CLS
1310 LOCATE 3,10
1320 PRINT TAB(14)"Oxide";TAB(32)"K-ratio";TAB(52)"Weight percent"
1340 FOR I=1 TO AA
1341 IF Z(I)=1 THEN CC$(I)="O"
1342 IF Z(I)=2 THEN CC$(I)="CO2"
1343 IF Z(I)=3 THEN CC$(I)="F"
1344 IF Z(I)=4 THEN CC$(I)="Na2O"
1345 IF Z(I)=5 THEN CC$(I)="MgO"
1346 IF Z(I)=6 THEN CC$(I)="Al2O3"
1347 IF Z(I)=7 THEN CC$(I)="SiO2"
1348 IF Z(I)=8 THEN CC$(I)="P2O5"
1349 IF Z(I)=9 THEN CC$(I)="SO3"
1350 IF Z(I)=10 THEN CC$(I)="Cl"
1351 IF Z(I)=11 THEN CC$(I)="K2O"
1352 IF Z(I)=12 THEN CC$(I)="CaO"
1353 IF Z(I)=13 THEN CC$(I)="TiO2"
1354 IF Z(I)=14 THEN CC$(I)="Cr2O3"
1355 IF Z(I)=15 THEN CC$(I)="MnO"
1356 IF Z(I)=16 THEN CC$(I)="FeO"
1357 IF Z(I)=17 THEN CC$(I)="CoO"
1358 IF Z(I)=18 THEN CC$(I)="NiO"
1359 IF Z(I)=19 THEN CC$(I)="CuO"
1360 IF Z(I)=20 THEN CC$(I)="ZnO"
1361 IF Z(I)=21 THEN CC$(I)="Rb2O"
1362 IF Z(I)=22 THEN CC$(I)="SrO"
1363 IF Z(I)=23 THEN CC$(I)="Y2O3"
1364 IF Z(I)=24 THEN CC$(I)="ZrO2"
1365 IF Z(I)=25 THEN CC$(I)="BaO"
1366 IF Z(I)=26 THEN CC$(I)="La2O3"
1367 IF Z(I)=27 THEN CC$(I)="Ce2O3"
1368 IF Z(I)=28 THEN CC$(I)="Pr2O3"
1369 IF Z(I)=29 THEN CC$(I)="Nd2O3"
1370 IF Z(I)=30 THEN CC$(I)="Sm2O3"
1371 IF Z(I)=31 THEN CC$(I)="Gd2O3"
1372 IF Z(I)=32 THEN CC$(I)="Dy2O3"
1373 IF Z(I)=33 THEN CC$(I)="Er2O3"
1374 IF Z(I)=34 THEN CC$(I)="HfO2"
1375 IF Z(I)=35 THEN CC$(I)="ThO2"
1376 IF Z(I)=36 THEN CC$(I)="UO2"
1377 NEXT I
1380 IF XX$="y" OR XX$="Y" GOTO 1400 ELSE 1500
1400 FOR I=1 TO AA
1410 LOCATE (4+I),14:PRINT"";CC$(I);TAB(33);
1420 PRINT USING"#.###";A5(I)/A6(I);
1430 PRINT TAB(55);
1440 PRINT USING"###.###";K(I)*100
1450 NEXT I
1460 PRINT
1470 PRINT TAB(14)"Total:";TAB(55);
1480 PRINT USING"###.###";S1*100
1490 GOTO 1600
1500 'Mixed stand.
1510 FOR I=1 TO AA
1520 LOCATE (4+I),14:PRINT"";CC$(I);TAB(33);
1530 PRINT USING"#.###";(A5(I)/A6(I)*W1(I)/B1(I));
1540 PRINT TAB(55);
1550 PRINT USING"###.###";K(I)*100
1560 NEXT I
1570 PRINT
1580 PRINT TAB(14)"Total:";TAB(55);
1590 PRINT USING"###.###";S1*100
1600 LOCATE 24,32:INPUT"Hard copy (y/n): ",HH$
1610 IF HH$="y" OR HH$="Y" GOTO 1700 ELSE 1990
1700 'Printer
1710 CLS
1740 LOCATE 13,23:INPUT"Please type sample name: ",SX$
1750 LPRINT:LPRINT:LPRINT:LPRINT
1760 LPRINT CHR$(27)+"G";
1770 LPRINT TAB(25)"BENCE-ALBEE CORRECTION PROGRAM"
1780 LPRINT CHR$(27)+"H";
1790 LPRINT:LPRINT
1800 LPRINT TAB(30)"  Date: ";DATE$
1810 LPRINT TAB(30)"  Time: ";TIME$
1820 LPRINT TAB(30)"Sample: ";SX$
1830 LPRINT:LPRINT
1840 LPRINT TAB(16)"Accelerating voltage: 15 keV"
1850 LPRINT TAB(16)"      Take-off angle: 38.5 degrees"
1880 LPRINT:LPRINT
1885 LPRINT TAB(14)"Oxide";TAB(32)"K-ratio";TAB(52)"Weight percent"
1887 LPRINT
1890 IF XX$="y" OR XX$="Y" GOTO 1900 ELSE 1950
1900 FOR I=1 TO AA
1905 LPRINT TAB(14)"";CC$(I);TAB(33);
1906 LPRINT USING"#.###";A5(I)/A6(I);
1907 LPRINT TAB(55);
1908 LPRINT USING"###.###";K(I)*100
1910 NEXT I
1920 LPRINT
1930 LPRINT TAB(14)"Total:";TAB(55);
1940 LPRINT USING"###.###";S1*100
1945 GOTO 1990
1950 FOR I=1 TO AA
1955 LPRINT TAB(14)"";CC$(I);TAB(33);
1956 LPRINT USING"#.###";A5(I)/A6(I)*W1(I)/B1(I);
1957 LPRINT TAB(55);
1958 LPRINT USING"###.###";K(I)*100
1959 NEXT I
1960 LPRINT
1970 LPRINT TAB(14)"Total:";TAB(55);
1980 LPRINT USING"###.###";S1*100
1981 LPRINT:LPRINT
1990 CLS
1991 LOCATE 13,27:INPUT"Another calculation (y/n): ",DDD$
1992 IF DDD$="y" OR DDD$="Y" GOTO 305 ELSE 2000
2000 CLOSE:CLS
2010 OPEN"i",#5,"menu.dat"
2020 INPUT #5,XY999
2030 IF XY999=1 GOTO 2050
2040 IF XY999=0 GOTO 2060
2050 CLOSE:RUN"ms8.exe":END
2060 CLOSE:SYSTEM:END
