50 ' Standardless quantitative analysis
60 ' Author:Henrik Kaker,29-10-1988
64 CLEAR
65 KEY OFF
70 OPEN"I",#1,"color.dat"
71 INPUT #1,X999
72 INPUT #1,Y999
73 INPUT #1,Z999
74 COLOR X999,Y999,Z999
80 OPEN"i",#2,"spt.dat"
81 INPUT #2,T20:T20=T20*.0001
82 INPUT #2,T21:T21=T21*.0001
83 INPUT #2,T22:T22=T22*.0001
84 INPUT #2,T23
90 CLS
95 DIM A(3,3),B(3,9),C(15),D(15),E(15),F(15),G(3),H(2,2),K(15),L(15),M(15)
96 DIM P(2,3),R(15),S(15),U(4),V(2,10),W(12),X(92),Z(15)
97 ' variable za del do 1000
98 DIM Z$(15),L$(15),A5(15),A6(15),AA(15),EE(15),UU(15),MM(15),OO(15),RR(15)
99 DIM UU1(15),EK(15),TX(15),FF(15),PP(15),SS(15),LL(15)
100 DIM XY(15),YY(15),CD(15),TH(15),M100(15),M200(15),M300(15)
101 DIM XX99(15),YY99(15),ZZ99(15)
110 LOCATE 5,22
120 PRINT"QUANTITATIVE NO-STANDARDS ANALYSIS"
130 X9=0
132 DEF FNE(Y)=Y^1.66667
134 DEF FNF(Y)=1+Y+.05*Y*Y
140 LOCATE 9,23
150 INPUT"Accelerating voltage (keV): ",V
160 LOCATE 11,29
170 INPUT"Tilt angle (degrees): ",TT1
180 T1=.0174533*TT1
190 LOCATE 13,25
200 INPUT"Take-off angle (degrees): ",DD
210 D=.017453*DD
220 LOCATE 15,31
230 INPUT"Number of elements: ",AAA
240 LOCATE 17,25
250 INPUT"Elements or oxides (e/o): ",UU$
260 IF UU$="E" OR UU$="e" GOTO 280
270 IF UU$="O" OR UU$="o" GOTO 470
280 CLS:LOCATE 3,18
285 PRINT TAB(21)"Element";TAB(38)"Line";TAB(52)"Int"
290 FOR N1=1 TO AAA
300 LOCATE (4+N1),24:INPUT"",Z$(N1)
301 IF Z$(N1)="C" OR Z$(N1)="c" THEN Z(N1)=6
302 IF Z$(N1)="N" OR Z$(N1)="n" THEN Z(N1)=7
303 IF Z$(N1)="O" OR Z$(N1)="o" THEN Z(N1)=8
304 IF Z$(N1)="F" OR Z$(N1)="f" THEN Z(N1)=9
305 IF Z$(N1)="Na" OR Z$(N1)="NA" OR Z$(N1)="na" THEN Z(N1)=11
306 IF Z$(N1)="Mg" OR Z$(N1)="MG" OR Z$(N1)="mg" THEN Z(N1)=12
307 IF Z$(N1)="Si" OR Z$(N1)="SI" OR Z$(N1)="si" THEN Z(N1)=14
308 IF Z$(N1)="S" OR Z$(N1)="s" THEN Z(N1)=16
309 IF Z$(N1)="Cl" OR Z$(N1)="CL" OR Z$(N1)="cl" THEN Z(N1)=17
310 IF Z$(N1)="K" OR Z$(N1)="k" THEN Z(N1)=19
311 IF Z$(N1)="Ca" OR Z$(N1)="CA" OR Z$(N1)="ca" THEN Z(N1)=20
312 IF Z$(N1)="Sc" OR Z$(N1)="SC" OR Z$(N1)="sc" THEN Z(N1)=21
313 IF Z$(N1)="Ti" OR Z$(N1)="TI" OR Z$(N1)="ti" THEN Z(N1)=22
314 IF Z$(N1)="V" OR Z$(N1)="v" THEN Z(N1)=23
315 IF Z$(N1)="Cr" OR Z$(N1)="CR" OR Z$(N1)="cr" THEN Z(N1)=24
316 IF Z$(N1)="Mn" OR Z$(N1)="MN" OR Z$(N1)="mn" THEN Z(N1)=25
317 IF Z$(N1)="Fe" OR Z$(N1)="FE" OR Z$(N1)="fe" THEN Z(N1)=26
318 IF Z$(N1)="Co" OR Z$(N1)="CO" OR Z$(N1)="co" THEN Z(N1)=27
319 IF Z$(N1)="Ni" OR Z$(N1)="NI" OR Z$(N1)="ni" THEN Z(N1)=28
320 IF Z$(N1)="Cu" OR Z$(N1)="CU" OR Z$(N1)="cu" THEN Z(N1)=29
321 IF Z$(N1)="Zn" OR Z$(N1)="ZN" OR Z$(N1)="zn" THEN Z(N1)=30
322 IF Z$(N1)="Ga" OR Z$(N1)="GA" OR Z$(N1)="ga" THEN Z(N1)=31
323 IF Z$(N1)="Ge" OR Z$(N1)="GE" OR Z$(N1)="ge" THEN Z(N1)=32
324 IF Z$(N1)="As" OR Z$(N1)="AS" OR Z$(N1)="as" THEN Z(N1)=33
325 IF Z$(N1)="Se" OR Z$(N1)="SE" OR Z$(N1)="se" THEN Z(N1)=34
326 IF Z$(N1)="Br" OR Z$(N1)="BR" OR Z$(N1)="br" THEN Z(N1)=35
327 IF Z$(N1)="Rb" OR Z$(N1)="Rb" OR Z$(N1)="rb" THEN Z(N1)=37
328 IF Z$(N1)="Sr" OR Z$(N1)="SR" OR Z$(N1)="sr" THEN Z(N1)=38
329 IF Z$(N1)="Y" OR Z$(N1)="y" THEN Z(N1)=39
330 IF Z$(N1)="Zr" OR Z$(N1)="ZR" OR Z$(N1)="zr" THEN Z(N1)=40
331 IF Z$(N1)="Nb" OR Z$(N1)="NB" OR Z$(N1)="nb" THEN Z(N1)=41
332 IF Z$(N1)="Mo" OR Z$(N1)="MO" OR Z$(N1)="mo" THEN Z(N1)=42
333 IF Z$(N1)="Tc" OR Z$(N1)="TC" OR Z$(N1)="tc" THEN Z(N1)=43
334 IF Z$(N1)="Ru" OR Z$(N1)="RU" OR Z$(N1)="ru" THEN Z(N1)=44
335 IF Z$(N1)="Rh" OR Z$(N1)="RH" OR Z$(N1)="rh" THEN Z(N1)=45
336 IF Z$(N1)="Pd" OR Z$(N1)="PD" OR Z$(N1)="pd" THEN Z(N1)=46
337 IF Z$(N1)="Ag" OR Z$(N1)="AG" OR Z$(N1)="ag" THEN Z(N1)=47
338 IF Z$(N1)="Cd" OR Z$(N1)="CD" OR Z$(N1)="cd" THEN Z(N1)=48
339 IF Z$(N1)="In" OR Z$(N1)="IN" OR Z$(N1)="in" THEN Z(N1)=49
340 IF Z$(N1)="Sn" OR Z$(N1)="SN" OR Z$(N1)="sn" THEN Z(N1)=50
341 IF Z$(N1)="Sb" OR Z$(N1)="SB" OR Z$(N1)="sb" THEN Z(N1)=51
342 IF Z$(N1)="Te" OR Z$(N1)="TE" OR Z$(N1)="te" THEN Z(N1)=52
343 IF Z$(N1)="I" OR Z$(N1)="i" THEN Z(N1)=53
344 IF Z$(N1)="Cs" OR Z$(N1)="CS" OR Z$(N1)="cs" THEN Z(N1)=55
345 IF Z$(N1)="Ba" OR Z$(N1)="BA" OR Z$(N1)="ba" THEN Z(N1)=56
346 IF Z$(N1)="La" OR Z$(N1)="LA" OR Z$(N1)="la" THEN Z(N1)=57
347 IF Z$(N1)="Ce" OR Z$(N1)="CE" OR Z$(N1)="ce" THEN Z(N1)=58
348 IF Z$(N1)="Pr" OR Z$(N1)="PR" OR Z$(N1)="pr" THEN Z(N1)=59
349 IF Z$(N1)="Nd" OR Z$(N1)="ND" OR Z$(N1)="nd" THEN Z(N1)=60
350 IF Z$(N1)="Pm" OR Z$(N1)="PM" OR Z$(N1)="pm" THEN Z(N1)=61
351 IF Z$(N1)="Al" OR Z$(N1)="AL" OR Z$(N1)="al" THEN Z(N1)=13
352 IF Z$(N1)="Sm" OR Z$(N1)="SM" OR Z$(N1)="sm" THEN Z(N1)=62
353 IF Z$(N1)="Eu" OR Z$(N1)="EU" OR Z$(N1)="eu" THEN Z(N1)=63
354 IF Z$(N1)="Gd" OR Z$(N1)="GD" OR Z$(N1)="gd" THEN Z(N1)=64
355 IF Z$(N1)="Tb" OR Z$(N1)="TB" OR Z$(N1)="tb" THEN Z(N1)=65
356 IF Z$(N1)="Dy" OR Z$(N1)="DY" OR Z$(N1)="dy" THEN Z(N1)=66
357 IF Z$(N1)="Ho" OR Z$(N1)="HO" OR Z$(N1)="ho" THEN Z(N1)=67
358 IF Z$(N1)="Er" OR Z$(N1)="ER" OR Z$(N1)="er" THEN Z(N1)=68
359 IF Z$(N1)="Tm" OR Z$(N1)="TM" OR Z$(N1)="tm" THEN Z(N1)=69
360 IF Z$(N1)="Yb" OR Z$(N1)="YB" OR Z$(N1)="yb" THEN Z(N1)=70
361 IF Z$(N1)="Lu" OR Z$(N1)="LU" OR Z$(N1)="lu" THEN Z(N1)=71
362 IF Z$(N1)="Hf" OR Z$(N1)="HF" OR Z$(N1)="hf" THEN Z(N1)=72
363 IF Z$(N1)="Ta" OR Z$(N1)="TA" OR Z$(N1)="ta" THEN Z(N1)=73
364 IF Z$(N1)="W" OR Z$(N1)="w" THEN Z(N1)=74
365 IF Z$(N1)="Re" OR Z$(N1)="RE" OR Z$(N1)="re" THEN Z(N1)=75
366 IF Z$(N1)="Os" OR Z$(N1)="OS" OR Z$(N1)="os" THEN Z(N1)=76
367 IF Z$(N1)="Ir" OR Z$(N1)="IR" OR Z$(N1)="ir" THEN Z(N1)=77
368 IF Z$(N1)="Pt" OR Z$(N1)="PT" OR Z$(N1)="pt" THEN Z(N1)=78
369 IF Z$(N1)="Au" OR Z$(N1)="AU" OR Z$(N1)="au" THEN Z(N1)=79
370 IF Z$(N1)="Hg" OR Z$(N1)="HG" OR Z$(N1)="hg" THEN Z(N1)=80
371 IF Z$(N1)="Tl" OR Z$(N1)="TL" OR Z$(N1)="tl" THEN Z(N1)=81
372 IF Z$(N1)="Pb" OR Z$(N1)="PB" OR Z$(N1)="pb" THEN Z(N1)=82
373 IF Z$(N1)="Bi" OR Z$(N1)="BI" OR Z$(N1)="bi" THEN Z(N1)=83
374 IF Z$(N1)="U" OR Z$(N1)="u" THEN Z(N1)=92
375 IF Z$(N1)="P" OR Z$(N1)="p" THEN Z(N1)=15
380 LOCATE (4+N1),39:INPUT"",L$(N1)
390 L(N1)=0
400 IF L$(N1)="K" OR L$(N1)="k" THEN L(N1)=1
410 IF L$(N1)="L" OR L$(N1)="l" THEN L(N1)=2
420 IF L$(N1)="M" OR L$(N1)="m" THEN L(N1)=3
430 IF L$(N1)="O" OR L$(N1)="o" THEN L(N1)=0
440 LOCATE (4+N1),52:INPUT"",A5(N1)
450 NEXT N1
460 GOTO 700
470 CLS:LOCATE 3,18
480 PRINT TAB(18)"Element";TAB(28)"Line";TAB(38)"Int";TAB(48)"Stehiom.ratio"
490 FOR N1=1 TO AAA
500 LOCATE (4+N1),21:INPUT"",Z$(N1)
510 IF Z$(N1)="C" OR Z$(N1)="c" THEN Z(N1)=6
511 IF Z$(N1)="N" OR Z$(N1)="n" THEN Z(N1)=7
512 IF Z$(N1)="O" OR Z$(N1)="o" THEN Z(N1)=8
513 IF Z$(N1)="F" OR Z$(N1)="f" THEN Z(N1)=9
514 IF Z$(N1)="Na" OR Z$(N1)="NA" OR Z$(N1)="na" THEN Z(N1)=11
515 IF Z$(N1)="Al" OR Z$(N1)="AL" OR Z$(N1)="al" THEN Z(N1)=13
516 IF Z$(N1)="Si" OR Z$(N1)="SI" OR Z$(N1)="si" THEN Z(N1)=14
517 IF Z$(N1)="P" OR Z$(N1)="p" THEN Z(N1)=15
518 IF Z$(N1)="S" OR Z$(N1)="s" THEN Z(N1)=16
519 IF Z$(N1)="Cl" OR Z$(N1)="CL" OR Z$(N1)="cl" THEN Z(N1)=17
520 IF Z$(N1)="K" OR Z$(N1)="k" THEN Z(N1)=19
521 IF Z$(N1)="Ca" OR Z$(N1)="CA" OR Z$(N1)="ca" THEN Z(N1)=20
522 IF Z$(N1)="Sc" OR Z$(N1)="SC" OR Z$(N1)="sc" THEN Z(N1)=21
523 IF Z$(N1)="Ti" OR Z$(N1)="TI" OR Z$(N1)="ti" THEN Z(N1)=22
524 IF Z$(N1)="V" OR Z$(N1)="v" THEN Z(N1)=23
525 IF Z$(N1)="Cr" OR Z$(N1)="CR" OR Z$(N1)="cr" THEN Z(N1)=24
526 IF Z$(N1)="Mn" OR Z$(N1)="MN" OR Z$(N1)="mn" THEN Z(N1)=25
527 IF Z$(N1)="Fe" OR Z$(N1)="FE" OR Z$(N1)="fe" THEN Z(N1)=26
528 IF Z$(N1)="Co" OR Z$(N1)="CO" OR Z$(N1)="co" THEN Z(N1)=27
529 IF Z$(N1)="Ni" OR Z$(N1)="NI" OR Z$(N1)="ni" THEN Z(N1)=28
530 IF Z$(N1)="Cu" OR Z$(N1)="CU" OR Z$(N1)="cu" THEN Z(N1)=29
531 IF Z$(N1)="Zn" OR Z$(N1)="ZN" OR Z$(N1)="zn" THEN Z(N1)=30
532 IF Z$(N1)="Mg" OR Z$(N1)="MG" OR Z$(N1)="mg" THEN Z(N1)=12
533 IF Z$(N1)="Ga" OR Z$(N1)="GA" OR Z$(N1)="ga" THEN Z(N1)=31
534 IF Z$(N1)="Ge" OR Z$(N1)="GE" OR Z$(N1)="ge" THEN Z(N1)=32
535 IF Z$(N1)="As" OR Z$(N1)="AS" OR Z$(N1)="as" THEN Z(N1)=33
536 IF Z$(N1)="Se" OR Z$(N1)="SE" OR Z$(N1)="se" THEN Z(N1)=34
537 IF Z$(N1)="Br" OR Z$(N1)="BR" OR Z$(N1)="br" THEN Z(N1)=35
538 IF Z$(N1)="Rb" OR Z$(N1)="RB" OR Z$(N1)="rb" THEN Z(N1)=37
539 IF Z$(N1)="Sr" OR Z$(N1)="SR" OR Z$(N1)="sr" THEN Z(N1)=38
540 IF Z$(N1)="Y" OR Z$(N1)="y" THEN Z(N1)=39
541 IF Z$(N1)="Zr" OR Z$(N1)="ZR" OR Z$(N1)="zr" THEN Z(N1)=40
542 IF Z$(N1)="Nb" OR Z$(N1)="NB" OR Z$(N1)="nb" THEN Z(N1)=41
543 IF Z$(N1)="Mo" OR Z$(N1)="MO" OR Z$(N1)="mo" THEN Z(N1)=42
544 IF Z$(N1)="Tc" OR Z$(N1)="TC" OR Z$(N1)="tc" THEN Z(N1)=43
545 IF Z$(N1)="Ru" OR Z$(N1)="RU" OR Z$(N1)="ru" THEN Z(N1)=44
546 IF Z$(N1)="Rh" OR Z$(N1)="RH" OR Z$(N1)="rh" THEN Z(N1)=45
547 IF Z$(N1)="Pd" OR Z$(N1)="PD" OR Z$(N1)="pd" THEN Z(N1)=46
548 IF Z$(N1)="Ag" OR Z$(N1)="AG" OR Z$(N1)="ag" THEN Z(N1)=47
549 IF Z$(N1)="Cd" OR Z$(N1)="CD" OR Z$(N1)="cd" THEN Z(N1)=48
550 IF Z$(N1)="In" OR Z$(N1)="IN" OR Z$(N1)="in" THEN Z(N1)=49
551 IF Z$(N1)="Sn" OR Z$(N1)="SN" OR Z$(N1)="sn" THEN Z(N1)=50
552 IF Z$(N1)="Sb" OR Z$(N1)="SB" OR Z$(N1)="sb" THEN Z(N1)=51
553 IF Z$(N1)="Te" OR Z$(N1)="TE" OR Z$(N1)="te" THEN Z(N1)=52
554 IF Z$(N1)="I" OR Z$(N1)="i" THEN Z(N1)=53
555 IF Z$(N1)="Cs" OR Z$(N1)="CS" OR Z$(N1)="cs" THEN Z(N1)=55
556 IF Z$(N1)="Ba" OR Z$(N1)="BA" OR Z$(N1)="ba" THEN Z(N1)=56
557 IF Z$(N1)="La" OR Z$(N1)="LA" OR Z$(N1)="la" THEN Z(N1)=57
558 IF Z$(N1)="Ce" OR Z$(N1)="CE" OR Z$(N1)="ce" THEN Z(N1)=58
559 IF Z$(N1)="Pr" OR Z$(N1)="PR" OR Z$(N1)="pr" THEN Z(N1)=59
560 IF Z$(N1)="Pm" OR Z$(N1)="PM" OR Z$(N1)="pm" THEN Z(N1)=61
561 IF Z$(N1)="Nd" OR Z$(N1)="ND" OR Z$(N1)="nd" THEN Z(N1)=60
562 IF Z$(N1)="Sm" OR Z$(N1)="SM" OR Z$(N1)="sm" THEN Z(N1)=62
563 IF Z$(N1)="Eu" OR Z$(N1)="EU" OR Z$(N1)="eu" THEN Z(N1)=63
564 IF Z$(N1)="Gd" OR Z$(N1)="GD" OR Z$(N1)="gd" THEN Z(N1)=64
565 IF Z$(N1)="Tb" OR Z$(N1)="TB" OR Z$(N1)="tb" THEN Z(N1)=65
566 IF Z$(N1)="Dy" OR Z$(N1)="DY" OR Z$(N1)="dy" THEN Z(N1)=66
567 IF Z$(N1)="Ho" OR Z$(N1)="HO" OR Z$(N1)="ho" THEN Z(N1)=67
568 IF Z$(N1)="Er" OR Z$(N1)="ER" OR Z$(N1)="er" THEN Z(N1)=68
569 IF Z$(N1)="Tm" OR Z$(N1)="TM" OR Z$(N1)="tm" THEN Z(N1)=69
570 IF Z$(N1)="Yb" OR Z$(N1)="YB" OR Z$(N1)="yb" THEN Z(N1)=70
571 IF Z$(N1)="Lu" OR Z$(N1)="LU" OR Z$(N1)="lu" THEN Z(N1)=71
572 IF Z$(N1)="Hf" OR Z$(N1)="HF" OR Z$(N1)="hf" THEN Z(N1)=72
573 IF Z$(N1)="Ta" OR Z$(N1)="TA" OR Z$(N1)="ta" THEN Z(N1)=73
574 IF Z$(N1)="W" OR Z$(N1)="w" THEN Z(N1)=74
575 IF Z$(N1)="Re" OR Z$(N1)="RE" OR Z$(N1)="re" THEN Z(N1)=75
576 IF Z$(N1)="Os" OR Z$(N1)="OS" OR Z$(N1)="os" THEN Z(N1)=76
577 IF Z$(N1)="Ir" OR Z$(N1)="IR" OR Z$(N1)="ir" THEN Z(N1)=77
578 IF Z$(N1)="Pt" OR Z$(N1)="PT" OR Z$(N1)="pt" THEN Z(N1)=78
579 IF Z$(N1)="Au" OR Z$(N1)="AU" OR Z$(N1)="au" THEN Z(N1)=79
580 IF Z$(N1)="Hg" OR Z$(N1)="HG" OR Z$(N1)="hg" THEN Z(N1)=80
581 IF Z$(N1)="Tl" OR Z$(N1)="TL" OR Z$(N1)="tl" THEN Z(N1)=81
582 IF Z$(N1)="Pb" OR Z$(N1)="PB" OR Z$(N1)="pb" THEN Z(N1)=82
583 IF Z$(N1)="Bi" OR Z$(N1)="BI" OR Z$(N1)="bi" THEN Z(N1)=83
584 IF Z$(N1)="U" OR Z$(N1)="u" THEN Z(N1)=92
589 L(N1)=0
590 LOCATE (4+N1),29:INPUT"",L$(N1)
600 IF L$(N1)="K" OR L$(N1)="k" THEN L(N1)=1
610 IF L$(N1)="L" OR L$(N1)="l" THEN L(N1)=2
620 IF L$(N1)="M" OR L$(N1)="m" THEN L(N1)=3
630 IF L$(N1)="O" OR L$(N1)="o" THEN L(N1)=0
640 LOCATE (4+N1),38:INPUT"",A5(N1)
650 LOCATE (4+N1),53:INPUT"",A6(N1)
660 NEXT N1
700 REM-K-RATIO CALC.
710 FOR N1=1 TO AAA
720 AA(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
730 IF L(N1)=1 THEN EE(N1)=5.706779E-03*Z(N1)^2.186
740 IF L(N1)=2 THEN EE(N1)=2.01587E-04*Z(N1)^2.5183
750 IF L(N1)=3 THEN EE(N1)=2.8537E-06*Z(N1)^3.11494
760 UU(N1)=V/EE(N1)
770 IF L(N1)=1 THEN MM(N1)=294477!*Z(N1)^(-2.56464)
780 IF L(N1)=2 THEN MM(N1)=1.90666E+07*Z(N1)^(-2.72348)
790 IF L(N1)=3 THEN MM(N1)=7.228677E+09*Z(N1)^(-3.58163)
800 IF L(N1)=1 THEN OO(N1)=(1*Z(N1)^4)/(1150000!+Z(N1)^4)
810 IF L(N1)=2 THEN OO(N1)=(3.555*Z(N1)^4)/(1.02E+08+Z(N1)^4)
820 IF L(N1)=3 THEN OO(N1)=(4.361*Z(N1)^4)/(7.5E+08+Z(N1)^4)
830 RR(N1)=(EXP(-.004*Z(N1)*(UU(N1)-1)^.3))*COS(.56*T1)
840 RR(N1)=RR(N1)*EXP((LOG(.0753/UU(N1)+.8994)*((1/COS(T1))-1-T1/90)))
850 UU1(N1)=(UU(N1)-1)^(5/3)
860 IF L(N1)=1 THEN EK(N1)=EXP(-5.49184+2.54555*LOG(Z(N1))-.128429*(LOG(Z(N1)))^2+.0120661*(LOG(Z(N1)))^3)
870 IF L(N1)=2 THEN EK(N1)=EXP(-13.2015+5.92457*LOG(Z(N1))-.790156*(LOG(Z(N1)))^2+.0560193*(LOG(Z(N1)))^3)
880 IF L(N1)=3 THEN EK(N1)=EXP(6.66542-11.2046*LOG(Z(N1))+3.58209*(LOG(Z(N1)))^2-.303821*(LOG(Z(N1)))^3)
881 ' Si(Li) efficiency
882 IF EK(N1)=<1.487 THEN M100=.3102*(12.3981/EK(N1))^3.001
883 IF EK(N1)>1.487 THEN M100=2.4604*.111*(12.3981/EK(N1))^3.03
884 IF EK(N1)=<1.487 THEN M200=1.759*(12.3981/EK(N1))^2.706
885 IF EK(N1)>1.487 AND EK(N1)=<2.0147 THEN M200=9.130901*1.8389*(12.3981/EK(N1))^2.94
886 IF EK(N1)>2.0147 THEN M200=19.57*(12.3981/EK(N1))^2.7345
887 IF EK(N1)=<1.487 THEN M300=41.17*(12.3981/EK(N1))^1.906
888 IF EK(N1)>1.487 AND EK(N1)<=2.2057 THEN M300=19.4943*.7588*(12.3981/EK(N1))^2.393
889 IF EK(N1)>2.2057 AND EK(N1)<=2.2911 THEN M300=19.4943*2.2057*(12.3981/EK(N1))^2.2
890 IF EK(N1)>2.2911 AND EK(N1)<=2.743 THEN M300=19.4943*2.2911*(12.3981/EK(N1))^2.4
891 IF EK(N1)>2.743 AND EK(N1)<=3.1478 THEN M300=19.4943*2.743*(12.3981/EK(N1))^2.4471
892 IF EK(N1)>3.1478 AND EK(N1)<=3.4249 THEN M300=19.4943*3.1478*(12.3981/EK(N1))^2.4471
893 IF EK(N1)>3.4249 AND EK(N1)<=11.9187 THEN M300=19.4943*3.4249*(12.3981/EK(N1))^2.575
894 IF EK(N1)>11.9187 AND EK(N1)<=13.7336 THEN M300=19.4943*11.9187*(12.3981/EK(N1))^2.3554
895 IF EK(N1)>13.7336 AND EK(N1)<=14.3528 THEN M300=19.4943*13.7336*(12.3981/EK(N1))^2.61439
896 IF EK(N1)>14.3528 THEN M300=19.4943*14.3528*(12.3981/EK(N1))^2.65
900 TX(N1)=EXP(-M100*(T20/COS(D))*1.85-M200*(T22/COS(D))*2.329-M300*(T21/COS(D))*19.3)*(1-EXP(-M200*(T23/COS(D))*2.329))
916 FF(N1)=1/(1+.0000013*MM(N1)*(COS(T1)/SIN(D))*(V^1.65-EE(N1)^1.65))^2
917 IF L(N1)=1 THEN PP(N1)=UU1(N1)*OO(N1)*TX(N1)*RR(N1)*FF(N1)/AA(N1)
918 IF L(N1)=2 THEN PP(N1)=UU1(N1)*OO(N1)*TX(N1)*RR(N1)*FF(N1)/AA(N1)
919 IF L(N1)=3 THEN PP(N1)=UU1(N1)*OO(N1)*TX(N1)*RR(N1)*FF(N1)/AA(N1)
920 NEXT N1
935 FOR N1=1 TO AAA
940 SS(N1)=A5(N1)/PP(N1)
942 NEXT N1
944 SS1=0
946 FOR N1=1 TO AAA
948 SS1=SS1+SS(N1)
950 NEXT N1
952 FOR N1=1 TO AAA
954 K(N1)=SS(N1)/SS1
956 NEXT N1
1000 FOR N1=1 TO AAA:AA(N1)=0:EE(N1)=0:UU(N1)=0:MM(N1)=0:OO(N1)=0:RR(N1)=0:UU1(N1)=0:EK(N1)=0:TX(N1)=0:PP(N1)=0:SS(N1)=0:NEXT N1
1001 T20=0:T21=0:T22=0:T23=0:T1=0:D=0:SS1=0
1060 REM ***DEFINE VARIABLES AND READ IN CONSTANTS ***
1070 REM ***A(3,3) ARE DATA FOR KA,LA,MA ENERGY CALC.***
1080 FOR I=1 TO 3
1090 FOR J=1 TO 3
1100 READ A(J,I)
1110 NEXT J
1120 NEXT I
1130 DATA -1.8860E-2,2.21859,-5.17083
1140 DATA -.123941,3.29533,-9.75836
1150 DATA -.47555,6.84662,-20.0833
1160 REM ***B(3,9) ARE DATA FOR ABS.EDGE CALC.***
1170 FOR I=1 TO 9
1180 FOR J=1 TO 3
1190 READ B(J,I)
1200 NEXT J
1210 NEXT I
1220 DATA -3.97391E-2,2.423,5.5091
1230 DATA -.033916,2.82526,9.03526
1240 DATA -8.65397E-2,3.32315,10.2505
1250 DATA -.228343,4.31172,12.0025
1260 DATA 1.25179,-7.838,-11.5803
1270 DATA .834903,-4.14925,-3.33802
1280 DATA .442217,-.979241,3.15348
1290 DATA .25141,.931913,8.03561
1300 DATA .272951,.688906,7.4243
1310 REM ***C(8) ARE CONCENTRATIONS OF ELEMENTS***
1320 REM ***D(8) IS GEOMETRY FACTOR***
1330 REM ***E(8) ARE EMISSION LINE ENERGIES OF ELEMENTS***
1340 REM ***F(8) ARE ABSORPTION EDGE ENERGIES OF ELEMENTS***
1350 REM ***G(3) ARE ABS EDGE JUMP RATIOS***
1360 FOR I=1 TO 3
1370 READ G(I)
1380 NEXT I
1390 DATA .88,.75,.5
1400 REM ***H(2,2) USED IN FLUOR.CALC.***
1410 FOR I=1 TO 2
1420 FOR J=1 TO 2
1430 READ H(J,I)
1440 NEXT J
1450 NEXT I
1460 DATA 2.373,-8.902
1470 DATA 2.946,-13.94
1480 REM ***I IS INDEX OF ELEMENT BEING CALCULATED***
1490 REM ***J IS INDEX OF MATRIX ELEMENT***
1500 REM ***K(8) ARE NORMALIZED INTENSITIES***
1510 REM ***L(8) ARE LINES ANALYZED 1=K,2=L,3=M,0=BY DIFF.***
1520 REM ***M(8) ARE USED FOR ABS COEFF.***
1530 REM ***N1=TOTAL NO. ELEM,N2=NO.ANALYZED,N3=# ITERATION***
1540 REM ***P(2,3)=FACTORS FOR INTERLINE FLUORESCENCE***
1550 FOR I=1 TO 2
1560 FOR J=1 TO 3
1570 READ P(I,J)
1580 NEXT J
1590 NEXT I
1600 DATA 1,.24,.02
1610 DATA 4.2,1,.02
1620 REM ***Q1 IS PARTIAL CONCENTRATION SUM***
1630 REM ***R(8) ARE USED FOR BACK SCATTER FACTORS***
1640 REM ***S(8) ARE USED FOR STOPPING POWERS***
1650 REM ***T0,T1,...,T9 ARE TEMPORARY SCRATCHPAD***
1660 REM ***U(4) ARE EXPONENTS IN MASS ABS COEFFICIENTS***
1670 REM ***V(2,10) ARE DATA FOR MASS ABS COEFFICIENTS***
1680 FOR I=1 TO 2
1690 FOR J=1 TO 10
1700 READ V(I,J)
1710 NEXT J
1720 NEXT I
1730 DATA 1,1,1.17,1.63,1,1.16,1.4,1.621,1.783,1
1740 DATA 1,2,2,2,3,3,3,3,3,4
1750 REM *** W(12)=DATA FOR MASS ABS COEFF. CALC.***
1760 FOR I=1 TO 12
1770 READ W(I)
1780 NEXT I
1790 DATA -.232229,-.254471,.256216,1.35917
1800 DATA 4.07005,4.76925,1.15119,-9.49212
1810 DATA -6.22075,-10.3788,-5.68485,18.6408
1820 REM ***X(92) ARE ATOMIC WEIGHTS***
1830 FOR I=1 TO 92
1840 READ X(I)
1850 NEXT I
1860 DATA 1.008,4.004,6.94,9.013,10.82,12.011
1870 DATA 14.007,16,19,20.18,22.99,24.31
1880 DATA 26.98,28.09,30.97,32.06,35.45,39.95
1890 DATA 39.1,40.08,44.96,47.9,50.94,52
1900 DATA 54.94,55.85,58.93,58.71,63.54,65.37
1910 DATA 69.72,72.59,74.92,78.96,79.91,83.8
1920 DATA 85.47,87.62,88.91,91.22,92.91,95.94
1930 DATA 99,101.1,102.9,106.4,107.9,112.4
1940 DATA 114.8,118.7,121.8,127.6,126.9,131.3
1950 DATA 132.9,137.3,138.9,140.1,140.9,144.2
1960 DATA 145,150.4,152,157.2,158.9,162.5
1970 DATA 164.9,167.3,168.9,173,175,178.5
1980 DATA 180.95,183.85,186.2,190.2,192.2,195.1
1990 DATA 196.97,200.6,204.4,207.2,209,210
2000 DATA 210,222,223,226,227,232,231,238
2010 REM ***Y IS FLUORESCENCE CORRECTION***
2020 REM ***Z(8) ARE AT.NO.'S OF ELEMENTS***
2150 D=COS(.0174533*TT1)/SIN(.0174533*DD)
2160 IF X9=1 GOTO 3510
2290 N1=N1-1
2300 N2=N1
2310 GOTO 2330
2320 N2=N1-1
2330 N3=1
2340 Q=0
2350 REM ***CALCULATION ENERGIES***
2360 FOR I=1 TO N2
2370 Z=LOG(Z(I))
2380 T2=L(I)*L(I)
2390 E(I)=EXP(A(1,L(I))*Z*Z+A(2,L(I))*Z+A(3,L(I)))
2400 F(I)=EXP(B(1,T2)*Z*Z+B(2,T2)*Z-B(3,T2))
2410 C(I)=K(I)
2420 Q=Q+C(I)
2430 NEXT I
2440 IF N1=N2 THEN GOTO 2490
2450 IF Q<=1 GOTO 2470
2460 Q=.99
2470 K(N1)=1-Q
2480 C(N1)=K(N1)
2490 Q=0
2500 REM ***CALCULATION Z CORRECTION***
2510 FOR I=1 TO N2
2520 FOR J=1 TO N1
2530 T6=V/F(I)
2533 IF T6<10 GOTO 2540
2536 T6=10
2540 T7=.00873*T6^3-.1669*T6^2+.9662*T6+.4523
2550 T8=.002703*T6^3-.05182*T6^2+.302*T6-.1836
2560 T9=.887-3.44/T6+9.33/T6^2-6.43/T6^3
2570 R(J)=T7-T8*LOG(T9*Z(J)+25)
2580 T2=9.76*Z(J)+58.5*Z(J)^(-.19)
2590 S(J)=2*Z(J)/X(Z(J))/(V+F(I))*LOG(583*(V+F(I))/T2)
2600 E=E(I)
2610 Z=Z(J)
2620 GOSUB 3310
2630 M(J)=T3
2640 NEXT J
2650 REM *** CALCULATION ABSORPTION CORRECTION***
2660 T2=.000003*(FNE(V)-FNE(F(I)))
2670 T3=T2*M(I)*D
2680 T3=FNF(T3)
2690 T4=T3
2700 T7=0
2710 T8=0
2720 T9=0
2730 FOR J=1 TO N1
2740 T7=T7+C(J)*S(J)
2750 T8=T8+C(J)*R(J)
2760 T9=T9+C(J)*M(J)
2770 NEXT J
2780 T3=T2*T9*D
2790 T3=FNF(T3)
2800 REM ***COMBINE Z & A CORRECTION***
2810 T2=R(I)*T3*T7/S(I)/T8/T4
2820 REM *** CALCULATION F CORRECTION***
2822 XX99(I)=S(I)*T8/R(I)/T7
2823 YY99(I)=T4/T3
2830 Y=0
2840 FOR J=1 TO N1
2850 Z=LOG(Z(J))
2860 T4=1
2870 E=EXP(A(1,T4)*Z*Z+A(2,T4)*Z+A(3,T4))
2880 IF E<F(I) GOTO 3480
2890 IF E>F(I)+5 THEN 3480
2900 T7=.5*EXP(H(1,T4)*LOG(Z(J))+H(2,T4))
2910 T8=0
2920 FOR T6=1 TO N1
2930 Z=Z(T6)
2940 GOSUB 3310
2950 T8=T8+T3*C(T6)
2960 NEXT T6
2970 T6=T9*D/T8
2980 T5=333000!/(FNE(V)-FNE(F(I)))/T8
2990 T6=LOG(1+T6)/T6+LOG(1+T5)/T5
3000 Z=Z(I)
3010 GOSUB 3310
3020 Z=LOG(Z(J))
3030 E=EXP(B(1,T4*T4)*Z*Z+B(2,T4*T4)*Z-B(3,T4*T4))
3040 T5=FNE((V/E-1)/(V/F(I)-1))*P(T4,L(I))*G(L(I))
3050 Y=Y+C(J)*T7*T5*T3*T6*X(Z(I))/X(Z(J))/T8
3060 NEXT J
3070 REM ***CALC.CONC.&NEXT APPROX.***
3080 T2=C(I)/T2*(1+Y)
3083 ZZ99(I)=(1+Y)
3085 IF X9= 1 GOTO 3530
3090 C(I)=(K(I)*C(I)*(1-T2))/(K(I)*(C(I)-T2)+T2*(1-C(I)))
3100 Q=Q+C(I)
3110 NEXT I
3115 IF X9=1 GOTO 3550
3120 IF N1=N2 THEN GOTO 3180
3130 IF Q<=1 GOTO 3160
3140 C(N1)=0
3150 GOTO 3180
3160 C(N1)=(1-Q)
3170 Q=1
3180 IF N3=3 THEN 3240
3190 N3=N3+1
3200 FOR I=1 TO N1
3210 C(I)=C(I)/Q
3220 NEXT I
3230 GOTO 2490
3240 PRINT
3250 CLS
3252 LOCATE 3,10
3253 IF UU$="E" OR UU$="e" GOTO 3254 ELSE 3279
3254 PRINT TAB(5)"Element";TAB(14)"Line";TAB(20)"K-ratio";TAB(30)"[Z]";TAB(37)"[A]";TAB(44)"[F]";TAB(50)"[ZAF]";TAB(60)"Weight %";TAB(70)"Atomic %"
3256 FOR I=1 TO N1:YY(I)=-1.42+1.97*Z(I)+.0103*Z(I)^2-.0000429*Z(I)^3:XY(I)=(C(I)*100)/YY(I):NEXT I
3258 XY1=0:FOR I=1 TO N1:XY1=XY1+XY(I):NEXT I
3260 FOR I=1 TO N1
3261 LOCATE (5+I),7:PRINT"";Z$(I);TAB(15);L$(I);TAB(21);
3262 PRINT USING"#.###";K(I)
3263 LOCATE (5+I),29:PRINT USING"#.###";XX99(I)
3264 LOCATE (5+I),36:PRINT USING"#.###";YY99(I)
3265 LOCATE (5+I),43:PRINT USING"#.###";ZZ99(I)
3266 LOCATE (5+I),50:PRINT USING"#.###";(XX99(I)*YY99(I)*ZZ99(I))
3275 LOCATE (5+I),60:PRINT USING"###.###";C(I)*100
3277 LOCATE (5+I),70:PRINT USING"###.###";(XY(I)*100)/XY1
3278 NEXT I:GOTO 3291
3279 FOR I=1 TO N1:YY(I)=-1.42+1.97*Z(I)+.0103*Z(I)^2-.0000429*Z(I)^3:NEXT I:ZZ=0:FOR I=1 TO N1:CD(I)=(C(I)*100)*(YY(I)+A6(I)*15.9994)/YY(I):ZZ=ZZ+CD(I):NEXT I:FOR I=1 TO N1:TH(I)=(CD(I)*100)/ZZ:NEXT I
3280 PRINT TAB(5)"Element";TAB(14)"Line";TAB(20)"K-ratio";TAB(30)"[Z]";TAB(37)"[A]";TAB(44)"[F]";TAB(50)"[ZAF]";TAB(60)"Weight %";TAB(70)"Atomic %"
3281 FOR I=1 TO N1
3282 LOCATE (5+I),7:PRINT"";Z$(I);TAB(15);L$(I);TAB(21);
3283 PRINT USING"#.###";K(I)
3284 LOCATE (5+I),29:PRINT USING"#.###";XX99(I)
3285 LOCATE (5+I),36:PRINT USING"#.###";YY99(I)
3286 LOCATE (5+I),43:PRINT USING"#.###";ZZ99(I)
3287 LOCATE (5+I),50:PRINT USING"#.###";(XX99(I)*YY99(I)*ZZ99(I))
3288 LOCATE (5+I),60:PRINT USING"###.###";C(I)*100
3289 LOCATE (5+I),70:PRINT USING"###.###";TH(I)
3290 NEXT I
3291 GOTO 3600
3300 REM ***SUBROUTINE FOR ABS.COEFF.ENERGY E IN ELEM. Z***
3310 T3=LOG(Z)
3320 U(1)=EXP(-.0045522*T3*T3-.0068535*T3+1.07018)
3330 U(2)=2.73
3340 U(3)=2.6
3350 U(4)=2.22
3360 IF Z<42 THEN 3380
3370 U(2)=EXP(-.113159*T3*T3+.836883*T3-.545969)
3380 T1=1
3390 IF T1=10 THEN 3420
3400 T0=EXP(B(1,T1)*T3*T3+B(2,T1)*T3-B(3,T1))
3410 IF E<T0 GOTO 3460
3420 T0=W(V(2,T1))*T3*T3+W(V(2,T1)+4)*T3+W(V(2,T1)+8)
3430 T0=EXP(T0)/V(1,T1)
3440 T3=T0*(12.398/E)^U(V(2,T1))
3450 RETURN
3460 T1=T1+1
3470 GOTO 3390
3480 IF T4=2 THEN 3060
3490 T4=2
3500 GOTO 2870
3510 LOCATE 13,10
3515 IF UU$="E" OR UU$="e" OR UU$="O" OR UU$="o" GOTO 3516
3516 PRINT TAB(21)"Element";TAB(38)"Line";TAB(52)"Weight %"
3520 GOTO 2160
3530 K(I)=T2
3540 GOTO 3110
3550 PRINT
3560 CLS:LOCATE 3,18:PRINT TAB(20)"Element";TAB(35)"Line";TAB(50)"K-ratio"
3570 FOR I=1 TO N1
3580 LOCATE (4+I),23:PRINT"";Z$(I);TAB(36)"";L$(I);TAB(51);
3585 PRINT USING"#.###";K(I)
3590 NEXT I
3600 REM-IZPIS REZULTATOV NA LINE PRINTER
3640 LOCATE 24,30
3650 INPUT"Hard copy (y/n): ",AB$
3660 IF AB$="N" OR AB$="n" GOTO 4000
3670 IF AB$="Y" OR AB$="y" GOTO 3680
3680 CLS:LOCATE 13,22
3690 INPUT"Please type sample name: ",SX$
3720 LPRINT:LPRINT:LPRINT:LPRINT
3725 LPRINT CHR$(27)+"G";
3730 LPRINT TAB(22)"QUANTITATIVE NO-STANDARDS ANALYSIS"
3731 LPRINT CHR$(27)+"H"
3740 LPRINT:LPRINT
3741 LPRINT TAB(30)"  Date: ";DATE$
3742 LPRINT TAB(30)"  Time: ";TIME$
3750 LPRINT TAB(30)"Sample: ";SX$
3760 LPRINT:LPRINT
3780 LPRINT TAB(16)"Accelerating voltage: ";V;" keV"
3790 LPRINT TAB(16)"          Tilt angle: ";TT1;" degrees"
3800 LPRINT TAB(16)"      Take-off angle: ";DD;" degrees"
3810 LPRINT TAB(16)"  Number of elements: ";AAA
3820 LPRINT:LPRINT
3825 IF UU$="E" OR UU$="e" GOTO 3830 ELSE 3900
3830 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(27)"Int";TAB(34)"K-ratio";TAB(44)"Weight %";TAB(55)"Atomic %"
3840 LPRINT
3850 FOR I=1 TO N1
3860 LPRINT TAB(12)"";Z$(I);TAB(20)"";L$(I);TAB(22);
3861 LPRINT USING"######.###";A5(I);
3862 LPRINT TAB(35);
3870 LPRINT USING"#.###";K(I);
3871 LPRINT TAB(44);
3872 LPRINT USING"###.###";C(I)*100;
3873 LPRINT TAB(55);
3874 LPRINT USING"###.###";(XY(I)*100)/XY1
3880 NEXT I
3890 LPRINT:LPRINT:GOTO 4000
3900 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(27)"Int";TAB(34)"K-ratio";TAB(44)"Weight %";TAB(55)"Weight % oxide"
3910 LPRINT
3920 FOR I=1 TO N1
3930 LPRINT TAB(12)"";Z$(I);TAB(20)"";L$(I);TAB(22);
3931 LPRINT USING"######.###";A5(I);
3932 LPRINT TAB(35);
3940 LPRINT USING"#.###";K(I);
3941 LPRINT TAB(45);
3942 LPRINT USING"###.###";C(I)*100;
3943 LPRINT TAB(58);
3944 LPRINT USING"###.###";TH(I)
3950 NEXT I
4000 CLS
4010 LOCATE 13,27:INPUT"Another calculation (y/n): ",DDD$
4020 IF DDD$="y" OR DDD$="Y" GOTO 64 ELSE 5000
5000 CLOSE:CLS
5010 OPEN"i",#5,"menu.dat"
5020 INPUT #5,XY999
5030 IF XY999=1 GOTO 5050
5040 IF XY999=0 GOTO 5060
5050 CLOSE:RUN"ms.exe":END
5060 CLOSE:SYSTEM:END
