50 ' program semiquantitative analysis
60 ' author:Henrik Kaker,29-10-1988
65 CLEAR
70 KEY OFF
80 OPEN"I",#1,"color.dat"
81 INPUT #1,X99
82 INPUT #1,Y99
83 INPUT #1,Z99
84 COLOR X99,Y99,Z99
90 OPEN"i",#2,"spt.dat"
91 INPUT #2,T20:T20=T20*.0001
92 INPUT #2,T21:T21=T21*.0001
93 INPUT #2,T22:T22=T22*.0001
94 INPUT #2,T23
100 CLS
105 DIM AAA(15),Z$(15),L$(15),L(15),A5(15),A6(15),A(15),E(15),O(15),U(15),Z(15)
106 DIM U1(15),M(15),R(15),EK(15),T(15),F(15),P(15),S(15),K(15),G(15),X(15),C(15)
107 DIM M100(15),M200(15),M300(15)
110 LOCATE 5,27
120 PRINT"SEMIQUANTITATIVE ANALYSIS"
140 LOCATE 8,23
150 INPUT"Accelerating voltage (keV): ",V
152 IF V>=1 AND V<=50 GOTO 160 ELSE 140
160 LOCATE 10,29
170 INPUT"Tilt angle (degrees): ",T1
172 IF T1>=0 AND T<=90 GOTO 180 ELSE 160
180 T1=.0174533*T1
190 LOCATE 12,25
200 INPUT"Take-off angle (degrees): ",D
202 IF D>=0 AND D<=90 GOTO 210 ELSE 190
210 D=.0174533*D
220 LOCATE 14,31
230 INPUT"Number of elements: ",AAA
240 LOCATE 16,25
250 INPUT"Elements or oxides (e/o) = ",UU$
260 IF UU$="E" OR UU$="e" GOTO 280
270 IF UU$="O" OR UU$="o" GOTO 470
280 CLS:LOCATE 3,18
285 PRINT TAB(21)"Element";TAB(38)"Line";TAB(52)"Int"
286 PRINT
290 FOR N1=1 TO AAA
300 LOCATE (4+N1),24:INPUT"",Z$(N1)
301 IF Z$(N1)="C" OR Z$(N1)="c" THEN Z(N1)=6
302 IF Z$(N1)="N" OR Z$(N1)="n" THEN Z(N1)=7
303 IF Z$(N1)="O" OR Z$(N1)="o" THEN Z(N1)=8
304 IF Z$(N1)="F" OR Z$(N1)="f" THEN Z(N1)=9
305 IF Z$(N1)="Na" OR Z$(N1)="NA" OR Z$(N1)="na" THEN Z(N1)=11
306 IF Z$(N1)="Mg" OR Z$(N1)="MG" OR Z$(N1)="mg" THEN Z(N1)=12
307 IF Z$(N1)="Al" OR Z$(N1)="AL" OR Z$(N1)="al" THEN Z(N1)=13
308 IF Z$(N1)="Si" OR Z$(N1)="SI" OR Z$(N1)="si" THEN Z(N1)=14
309 IF Z$(N1)="S" OR Z$(N1)="s" THEN Z(N1)=16
310 IF Z$(N1)="Cl" OR Z$(N1)="CL" OR Z$(N1)="cl" THEN Z(N1)=17
311 IF Z$(N1)="K" OR Z$(N1)="k" THEN Z(N1)=19
312 IF Z$(N1)="Ca" OR Z$(N1)="CA" OR Z$(N1)="ca" THEN Z(N1)=20
313 IF Z$(N1)="Sc" OR Z$(N1)="SC" OR Z$(N1)="sc" THEN Z(N1)=21
314 IF Z$(N1)="Ti" OR Z$(N1)="TI" OR Z$(N1)="ti" THEN Z(N1)=22
315 IF Z$(N1)="V" OR Z$(N1)="v" THEN Z(N1)=23
316 IF Z$(N1)="Cr" OR Z$(N1)="CR" OR Z$(N1)="cr" THEN Z(N1)=24
317 IF Z$(N1)="Mn" OR Z$(N1)="MN" OR Z$(N1)="mn" THEN Z(N1)=25
318 IF Z$(N1)="Fe" OR Z$(N1)="FE" OR Z$(N1)="fe" THEN Z(N1)=26
319 IF Z$(N1)="Co" OR Z$(N1)="CO" OR Z$(N1)="co" THEN Z(N1)=27
320 IF Z$(N1)="Ni" OR Z$(N1)="NI" OR Z$(N1)="ni" THEN Z(N1)=28
321 IF Z$(N1)="Cu" OR Z$(N1)="CU" OR Z$(N1)="cu" THEN Z(N1)=29
322 IF Z$(N1)="Zn" OR Z$(N1)="ZN" OR Z$(N1)="zn" THEN Z(N1)=30
323 IF Z$(N1)="Ga" OR Z$(N1)="GA" OR Z$(N1)="ga" THEN Z(N1)=31
324 IF Z$(N1)="Ge" OR Z$(N1)="GE" OR Z$(N1)="ge" THEN Z(N1)=32
325 IF Z$(N1)="As" OR Z$(N1)="AS" OR Z$(N1)="as" THEN Z(N1)=33
326 IF Z$(N1)="Se" OR Z$(N1)="SE" OR Z$(N1)="se" THEN Z(N1)=34
327 IF Z$(N1)="Br" OR Z$(N1)="BR" OR Z$(N1)="br" THEN Z(N1)=35
328 IF Z$(N1)="Rb" OR Z$(N1)="RB" OR Z$(N1)="rb" THEN Z(N1)=37
329 IF Z$(N1)="Sr" OR Z$(N1)="SR" OR Z$(N1)="sr" THEN Z(N1)=38
330 IF Z$(N1)="Y" OR Z$(N1)="y" THEN Z(N1)=39
331 IF Z$(N1)="Zr" OR Z$(N1)="ZR" OR Z$(N1)="zr" THEN Z(N1)=40
332 IF Z$(N1)="Nb" OR Z$(N1)="NB" OR Z$(N1)="nb" THEN Z(N1)=41
333 IF Z$(N1)="Mo" OR Z$(N1)="MO" OR Z$(N1)="mo" THEN Z(N1)=42
334 IF Z$(N1)="Tc" OR Z$(N1)="TC" OR Z$(N1)="tc" THEN Z(N1)=43
335 IF Z$(N1)="Ru" OR Z$(N1)="RU" OR Z$(N1)="ru" THEN Z(N1)=44
336 IF Z$(N1)="Rh" OR Z$(N1)="RH" OR Z$(N1)="rh" THEN Z(N1)=45
337 IF Z$(N1)="Pd" OR Z$(N1)="PD" OR Z$(N1)="pd" THEN Z(N1)=46
338 IF Z$(N1)="Ag" OR Z$(N1)="AG" OR Z$(N1)="ag" THEN Z(N1)=47
339 IF Z$(N1)="Cd" OR Z$(N1)="CD" OR Z$(N1)="cd" THEN Z(N1)=48
340 IF Z$(N1)="In" OR Z$(N1)="IN" OR Z$(N1)="in" THEN Z(N1)=49
341 IF Z$(N1)="Sn" OR Z$(N1)="SN" OR Z$(N1)="sn" THEN Z(N1)=50
342 IF Z$(N1)="Sb" OR Z$(N1)="SB" OR Z$(N1)="sb" THEN Z(N1)=51
343 IF Z$(N1)="Te" OR Z$(N1)="TE" OR Z$(N1)="te" THEN Z(N1)=52
344 IF Z$(N1)="I" OR Z$(N1)="i" THEN Z(N1)=53
345 IF Z$(N1)="Cs" OR Z$(N1)="CS" OR Z$(N1)="cs" THEN Z(N1)=55
346 IF Z$(N1)="Ba" OR Z$(N1)="BA" OR Z$(N1)="ba" THEN Z(N1)=56
347 IF Z$(N1)="La" OR Z$(N1)="LA" OR Z$(N1)="la" THEN Z(N1)=57
348 IF Z$(N1)="Ce" OR Z$(N1)="CE" OR Z$(N1)="ce" THEN Z(N1)=58
349 IF Z$(N1)="Pr" OR Z$(N1)="PR" OR Z$(N1)="pr" THEN Z(N1)=59
350 IF Z$(N1)="Nd" OR Z$(N1)="ND" OR Z$(N1)="nd" THEN Z(N1)=60
351 IF Z$(N1)="Pm" OR Z$(N1)="PM" OR Z$(N1)="pm" THEN Z(N1)=61
352 IF Z$(N1)="Sm" OR Z$(N1)="SM" OR Z$(N1)="sm" THEN Z(N1)=62
353 IF Z$(N1)="Eu" OR Z$(N1)="EU" OR Z$(N1)="eu" THEN Z(N1)=63
354 IF Z$(N1)="Gd" OR Z$(N1)="GD" OR Z$(N1)="gd" THEN Z(N1)=64
355 IF Z$(N1)="Tb" OR Z$(N1)="TB" OR Z$(N1)="tb" THEN Z(N1)=65
356 IF Z$(N1)="Dy" OR Z$(N1)="DY" OR Z$(N1)="dy" THEN Z(N1)=66
357 IF Z$(N1)="Ho" OR Z$(N1)="HO" OR Z$(N1)="ho" THEN Z(N1)=67
358 IF Z$(N1)="Er" OR Z$(N1)="ER" OR Z$(N1)="er" THEN Z(N1)=68
359 IF Z$(N1)="Tm" OR Z$(N1)="TM" OR Z$(N1)="tm" THEN Z(N1)=69
360 IF Z$(N1)="Yb" OR Z$(N1)="YB" OR Z$(N1)="yb" THEN Z(N1)=70
361 IF Z$(N1)="Lu" OR Z$(N1)="LU" OR Z$(N1)="lu" THEN Z(N1)=71
362 IF Z$(N1)="Hf" OR Z$(N1)="HF" OR Z$(N1)="hf" THEN Z(N1)=72
363 IF Z$(N1)="Ta" OR Z$(N1)="TA" OR Z$(N1)="ta" THEN Z(N1)=73
364 IF Z$(N1)="W" OR Z$(N1)="w" THEN Z(N1)=74
365 IF Z$(N1)="Re" OR Z$(N1)="RE" OR Z$(N1)="re" THEN Z(N1)=75
366 IF Z$(N1)="Os" OR Z$(N1)="OS" OR Z$(N1)="os" THEN Z(N1)=76
367 IF Z$(N1)="Ir" OR Z$(N1)="IR" OR Z$(N1)="ir" THEN Z(N1)=77
368 IF Z$(N1)="Pt" OR Z$(N1)="PT" OR Z$(N1)="pt" THEN Z(N1)=78
369 IF Z$(N1)="Au" OR Z$(N1)="AU" OR Z$(N1)="au" THEN Z(N1)=79
370 IF Z$(N1)="Hg" OR Z$(N1)="HG" OR Z$(N1)="hg" THEN Z(N1)=80
371 IF Z$(N1)="Tl" OR Z$(N1)="TL" OR Z$(N1)="tl" THEN Z(N1)=81
372 IF Z$(N1)="Pb" OR Z$(N1)="PB" OR Z$(N1)="pb" THEN Z(N1)=82
373 IF Z$(N1)="Bi" OR Z$(N1)="BI" OR Z$(N1)="bi" THEN Z(N1)=83
374 IF Z$(N1)="U" OR Z$(N1)="u" THEN Z(N1)=92
375 IF Z$(N1)="P" OR Z$(N1)="p" THEN Z(N1)=15
380 LOCATE (4+N1),39:INPUT"",L$(N1)
390 L(N1)=0
400 IF L$(N1)="K" OR L$(N1)="k" THEN L(N1)=1
410 IF L$(N1)="L" OR L$(N1)="l" THEN L(N1)=2
420 IF L$(N1)="M" OR L$(N1)="m" THEN L(N1)=3
430 IF L$(N1)="O" OR L$(N1)="o" THEN L(N1)=0
440 LOCATE (4+N1),52:INPUT"",A5(N1)
450 NEXT N1
460 GOTO 700
470 CLS:LOCATE 3,18
480 PRINT TAB(18)"Element";TAB(28)"Line";TAB(38)"Int";TAB(48)"Stehiom.ratio"
490 FOR N1=1 TO AAA
500 LOCATE (4+N1),21:INPUT"",Z$(N1)
510 IF Z$(N1)="C" OR Z$(N1)="c" THEN Z(N1)=6
511 IF Z$(N1)="N" OR Z$(N1)="n" THEN Z(N1)=7
512 IF Z$(N1)="O" OR Z$(N1)="o" THEN Z(N1)=8
513 IF Z$(N1)="F" OR Z$(N1)="f" THEN Z(N1)=9
514 IF Z$(N1)="Na" OR Z$(N1)="NA" OR Z$(N1)="na" THEN Z(N1)=11
515 IF Z$(N1)="Mg" OR Z$(N1)="MG" OR Z$(N1)="mg" THEN Z(N1)=12
516 IF Z$(N1)="Al" OR Z$(N1)="AL" OR Z$(N1)="al" THEN Z(N1)=13
517 IF Z$(N1)="Si" OR Z$(N1)="SI" OR Z$(N1)="si" THEN Z(N1)=14
518 IF Z$(N1)="P" OR Z$(N1)="p" THEN Z(N1)=15
519 IF Z$(N1)="S" OR Z$(N1)="s" THEN Z(N1)=16
520 IF Z$(N1)="Cl" OR Z$(N1)="CL" OR Z$(N1)="cl" THEN Z(N1)=17
521 IF Z$(N1)="K" OR Z$(N1)="k" THEN Z(N1)=19
522 IF Z$(N1)="Ca" OR Z$(N1)="CA" OR Z$(N1)="ca" THEN Z(N1)=20
523 IF Z$(N1)="Sc" OR Z$(N1)="SC" OR Z$(N1)="sc" THEN Z(N1)=21
524 IF Z$(N1)="Ti" OR Z$(N1)="TI" OR Z$(N1)="ti" THEN Z(N1)=22
525 IF Z$(N1)="V" OR Z$(N1)="v" THEN Z(N1)=23
526 IF Z$(N1)="Cr" OR Z$(N1)="CR" OR Z$(N1)="cr" THEN Z(N1)=24
527 IF Z$(N1)="Mn" OR Z$(N1)="MN" OR Z$(N1)="mn" THEN Z(N1)=25
528 IF Z$(N1)="Fe" OR Z$(N1)="FE" OR Z$(N1)="fe" THEN Z(N1)=26
529 IF Z$(N1)="Co" OR Z$(N1)="CO" OR Z$(N1)="co" THEN Z(N1)=27
530 IF Z$(N1)="Ni" OR Z$(N1)="NI" OR Z$(N1)="ni" THEN Z(N1)=28
531 IF Z$(N1)="Cu" OR Z$(N1)="CU" OR Z$(N1)="cu" THEN Z(N1)=29
532 IF Z$(N1)="Zn" OR Z$(N1)="ZN" OR Z$(N1)="zn" THEN Z(N1)=30
533 IF Z$(N1)="Ga" OR Z$(N1)="GA" OR Z$(N1)="ga" THEN Z(N1)=31
534 IF Z$(N1)="Ge" OR Z$(N1)="GE" OR Z$(N1)="ge" THEN Z(N1)=32
535 IF Z$(N1)="As" OR Z$(N1)="AS" OR Z$(N1)="as" THEN Z(N1)=33
536 IF Z$(N1)="Se" OR Z$(N1)="SE" OR Z$(N1)="se" THEN Z(N1)=34
537 IF Z$(N1)="Br" OR Z$(N1)="BR" OR Z$(N1)="br" THEN Z(N1)=35
538 IF Z$(N1)="Rb" OR Z$(N1)="RB" OR Z$(N1)="rb" THEN Z(N1)=37
539 IF Z$(N1)="Sr" OR Z$(N1)="SR" OR Z$(N1)="sr" THEN Z(N1)=38
540 IF Z$(N1)="Y" OR Z$(N1)="y" THEN Z(N1)=39
541 IF Z$(N1)="Zr" OR Z$(N1)="ZR" OR Z$(N1)="zr" THEN Z(N1)=40
542 IF Z$(N1)="Nb" OR Z$(N1)="NB" OR Z$(N1)="nb" THEN Z(N1)=41
543 IF Z$(N1)="Mo" OR Z$(N1)="MO" OR Z$(N1)="mo" THEN Z(N1)=42
544 IF Z$(N1)="Tc" OR Z$(N1)="TC" OR Z$(N1)="tc" THEN Z(N1)=43
545 IF Z$(N1)="Ru" OR Z$(N1)="RU" OR Z$(N1)="ru" THEN Z(N1)=44
546 IF Z$(N1)="Rh" OR Z$(N1)="RH" OR Z$(N1)="rh" THEN Z(N1)=45
547 IF Z$(N1)="Pd" OR Z$(N1)="PD" OR Z$(N1)="pd" THEN Z(N1)=46
548 IF Z$(N1)="Ag" OR Z$(N1)="AG" OR Z$(N1)="ag" THEN Z(N1)=47
549 IF Z$(N1)="Cd" OR Z$(N1)="CD" OR Z$(N1)="cd" THEN Z(N1)=48
550 IF Z$(N1)="In" OR Z$(N1)="IN" OR Z$(N1)="in" THEN Z(N1)=49
551 IF Z$(N1)="Sn" OR Z$(N1)="SN" OR Z$(N1)="sn" THEN Z(N1)=50
552 IF Z$(N1)="Sb" OR Z$(N1)="SB" OR Z$(N1)="sb" THEN Z(N1)=51
553 IF Z$(N1)="Te" OR Z$(N1)="TE" OR Z$(N1)="te" THEN Z(N1)=52
554 IF Z$(N1)="I" OR Z$(N1)="i" THEN Z(N1)=53
555 IF Z$(N1)="Cs" OR Z$(N1)="CS" OR Z$(N1)="cs" THEN Z(N1)=55
556 IF Z$(N1)="Ba" OR Z$(N1)="BA" OR Z$(N1)="ba" THEN Z(N1)=56
557 IF Z$(N1)="La" OR Z$(N1)="LA" OR Z$(N1)="la" THEN Z(N1)=57
558 IF Z$(N1)="Ce" OR Z$(N1)="CE" OR Z$(N1)="ce" THEN Z(N1)=58
559 IF Z$(N1)="Pr" OR Z$(N1)="PR" OR Z$(N1)="pr" THEN Z(N1)=59
560 IF Z$(N1)="Nd" OR Z$(N1)="ND" OR Z$(N1)="nd" THEN Z(N1)=60
561 IF Z$(N1)="Pm" OR Z$(N1)="PM" OR Z$(N1)="pm" THEN Z(N1)=61
562 IF Z$(N1)="Sm" OR Z$(N1)="SM" OR Z$(N1)="sm" THEN Z(N1)=62
563 IF Z$(N1)="Eu" OR Z$(N1)="EU" OR Z$(N1)="eu" THEN Z(N1)=63
564 IF Z$(N1)="Gd" OR Z$(N1)="GD" OR Z$(N1)="gd" THEN Z(N1)=64
565 IF Z$(N1)="Tb" OR Z$(N1)="TB" OR Z$(N1)="tb" THEN Z(N1)=65
566 IF Z$(N1)="Dy" OR Z$(N1)="DY" OR Z$(N1)="dy" THEN Z(N1)=66
567 IF Z$(N1)="Ho" OR Z$(N1)="HO" OR Z$(N1)="ho" THEN Z(N1)=67
568 IF Z$(N1)="Er" OR Z$(N1)="ER" OR Z$(N1)="er" THEN Z(N1)=68
569 IF Z$(N1)="Tm" OR Z$(N1)="TM" OR Z$(N1)="tm" THEN Z(N1)=69
570 IF Z$(N1)="Yb" OR Z$(N1)="YB" OR Z$(N1)="yb" THEN Z(N1)=70
571 IF Z$(N1)="Lu" OR Z$(N1)="LU" OR Z$(N1)="lu" THEN Z(N1)=71
572 IF Z$(N1)="Hf" OR Z$(N1)="HF" OR Z$(N1)="hf" THEN Z(N1)=72
573 IF Z$(N1)="Ta" OR Z$(N1)="TA" OR Z$(N1)="ta" THEN Z(N1)=73
574 IF Z$(N1)="W" OR Z$(N1)="w" THEN Z(N1)=74
575 IF Z$(N1)="Re" OR Z$(N1)="RE" OR Z$(N1)="re" THEN Z(N1)=75
576 IF Z$(N1)="Os" OR Z$(N1)="OS" OR Z$(N1)="os" THEN Z(N1)=76
577 IF Z$(N1)="Ir" OR Z$(N1)="IR" OR Z$(N1)="ir" THEN Z(N1)=77
578 IF Z$(N1)="Pt" OR Z$(N1)="PT" OR Z$(N1)="pt" THEN Z(N1)=78
579 IF Z$(N1)="Au" OR Z$(N1)="AU" OR Z$(N1)="au" THEN Z(N1)=79
580 IF Z$(N1)="Hg" OR Z$(N1)="HG" OR Z$(N1)="hg" THEN Z(N1)=80
581 IF Z$(N1)="Tl" OR Z$(N1)="TL" OR Z$(N1)="tl" THEN Z(N1)=81
582 IF Z$(N1)="Pb" OR Z$(N1)="PB" OR Z$(N1)="pb" THEN Z(N1)=82
583 IF Z$(N1)="Bi" OR Z$(N1)="BI" OR Z$(N1)="bi" THEN Z(N1)=83
584 IF Z$(N1)="U" OR Z$(N1)="u" THEN Z(N1)=92
589 L(N1)=0
590 LOCATE (4+N1),29:INPUT"",L$(N1)
600 IF L$(N1)="K" OR L$(N1)="k" THEN L(N1)=1
610 IF L$(N1)="L" OR L$(N1)="l" THEN L(N1)=2
620 IF L$(N1)="M" OR L$(N1)="m" THEN L(N1)=3
630 IF L$(N1)="O" OR L$(N1)="o" THEN L(N1)=0
640 LOCATE (4+N1),38:INPUT"",A5(N1)
645 LOCATE (4+N1),53:INPUT"",A6(N1)
660 NEXT N1
700 REM-IZRACUN
710 FOR N1=1 TO AAA
720 A(N1)=-1.42+1.97*Z(N1)+.0103*Z(N1)^2-.0000429*Z(N1)^3
730 IF L(N1)=1 THEN E(N1)=5.706779E-03*Z(N1)^2.186
740 IF L(N1)=2 THEN E(N1)=2.01587E-04*Z(N1)^2.5183
750 IF L(N1)=3 THEN E(N1)=2.8537E-06*Z(N1)^3.11494
760 U(N1)=V/E(N1)
770 IF L(N1)=1 THEN M(N1)=294477!*Z(N1)^(-2.56464)
780 IF L(N1)=2 THEN M(N1)=1.90666E+07*Z(N1)^(-2.72348)
790 IF L(N1)=3 THEN M(N1)=7.22867E+09*Z(N1)^(-3.58163)
800 IF L(N1)=1 THEN O(N1)=(1*Z(N1)^4)/(1150000!+Z(N1)^4)
810 IF L(N1)=2 THEN O(N1)=(3.555*Z(N1)^4)/(1.02E+08+Z(N1)^4)
820 IF L(N1)=3 THEN O(N1)=(4.361*Z(N1)^4)/(7.5E+08+Z(N1)^4)
830 R(N1)=(EXP(-.004*Z(N1)*(U(N1)-1)^.3))*COS(.56*T1)
840 R(N1)=R(N1)*EXP((LOG(.0753/U(N1)+.8994)*((1/COS(T1))-1-T1/90)))
850 U1(N1)=(U(N1)-1)^(5/3)
860 IF L(N1)=1 THEN EK(N1)=EXP(-5.49184+2.54555*LOG(Z(N1))-.128429*(LOG(Z(N1)))^2+.0120661*(LOG(Z(N1)))^3)
870 IF L(N1)=2 THEN EK(N1)=EXP(-13.2015+5.92457*LOG(Z(N1))-.790156*(LOG(Z(N1)))^2+.0560193*(LOG(Z(N1)))^3)
872 IF L(N1)=3 THEN EK(N1)=EXP(6.66542-11.2046*LOG(Z(N1))+3.58209*(LOG(Z(N1)))^2-.303821*(LOG(Z(N1)))^3)
875 ' izracun izkoristka spektrometra
881 IF EK(N1)=<1.487 THEN M100=.3102*(12.3981/EK(N1))^3.001
882 IF EK(N1)>1.487 THEN M100=2.4604*.111*(12.3981/EK(N1))^3.03
883 IF EK(N1)=<1.487 THEN M200=1.759*(12.3981/EK(N1))^2.706
884 IF EK(N1)>1.487 AND EK(N1)<=2.0147 THEN M200=9.130901*1.8389*(12.3981/EK(N1))^2.94
885 IF EK(N1)>2.0147 THEN M200=19.57*(12.3981/EK(N1))^2.7345
886 IF EK(N1)<=1.487 THEN M300=41.17*(12.3981/EK(N1))^1.906
887 IF EK(N1)>1.487 AND EK(N1)<=2.2057 THEN M300=19.4943*.7588*(12.3981/EK(N1))^2.393
888 IF EK(N1)>2.2057 AND EK(N1)<=2.2911 THEN M300=19.4943*2.2057*(12.3981/EK(N1))^2.2
889 IF EK(N1)>2.2911 AND EK(N1)<=2.743 THEN M300=19.4943*2.2911*(12.3981/EK(N1))^2.4
890 IF EK(N1)>2.743 AND EK(N1)<=3.1478 THEN M300=19.4943*2.743*(12.3981/EK(N1))^2.4471
891 IF EK(N1)>3.1478 AND EK(N1)<=3.4249 THEN M300=19.4943*3.1478*(12.3981/EK(N1))^2.4471
892 IF EK(N1)>3.4249 AND EK(N1)<=11.9187 THEN M300=19.4943*3.4249*(12.3981/EK(N1))^2.575
893 IF EK(N1)>11.9187 AND EK(N1)<=13.7336 THEN M300=19.4943*11.9187*(12.3981/EK(N1))^2.3554
894 IF EK(N1)>13.7336 AND EK(N1)<=14.3528 THEN M300=19.4943*13.7336*(12.3981/EK(N1))^2.61439
895 IF EK(N1)>14.3528 THEN M300=19.4943*14.3528*(12.3981/EK(N1))^2.65
900 T(N1)=EXP(-M100*(T20/COS(D))*1.85-M200*(T22/COS(D))*2.329-M300*(T21/COS(D))*19.3)*(1-EXP(-M200*(T23/COS(D))*2.329))
916 F(N1)=1/(1+.0000013*M(N1)*(COS(T1)/SIN(D))*(V^1.65-E(N1)^1.65))^2
917 IF L(N1)=1 THEN P(N1)=U1(N1)*O(N1)*T(N1)*R(N1)*F(N1)/A(N1)
918 IF L(N1)=2 THEN P(N1)=U1(N1)*O(N1)*T(N1)*R(N1)*F(N1)/A(N1)
919 IF L(N1)=3 THEN P(N1)=U1(N1)*O(N1)*T(N1)*R(N1)*F(N1)/A(N1)
920 NEXT N1
922 IF UU$="E" OR UU$="e" GOTO 930
924 IF UU$="O" OR UU$="o" GOTO 1100
930 REM-IZRACUN KONCENTRACIJ IN K-RAZMERIJ
940 FOR N1=1 TO AAA
942 S(N1)=A5(N1)/P(N1)
944 NEXT N1
946 SS=0
948 FOR N1=1 TO AAA
950 SS=SS+S(N1)
952 NEXT N1
954 FOR N1=1 TO AAA
955 K(N1)=S(N1)/SS
956 NEXT N1
960 FOR N1=1 TO AAA
962 G(N1)=(K(N1)*100)/A(N1)
964 NEXT N1
966 GG=0
968 FOR N1=1 TO AAA
970 GG=GG+G(N1)
980 NEXT N1
1000 CLS
1010 LOCATE 3,10
1020 PRINT TAB(8)"Element";TAB(19)"Line";TAB(28)"K-ratio";TAB(41)"Weight percent";TAB(58)"Atomic percent"
1030 FOR N1=1 TO AAA
1040 LOCATE (5+N1),10:PRINT"";Z$(N1);TAB(20);L$(N1);TAB(29);
1050 PRINT USING"#.###";K(N1)
1060 LOCATE (5+N1),44:PRINT USING"###.###";K(N1)*100
1070 LOCATE (5+N1),62:PRINT USING"###.###";(G(N1)*100)/GG
1080 NEXT N1
1090 GOTO 1380
1100 REM-IZRACUN KONCENTRACIJ ZA OKSIDE
1110 FOR N1=1 TO AAA
1120 S(N1)=A5(N1)/P(N1)
1130 NEXT N1
1140 SS=0
1150 FOR N1=1 TO AAA
1160 SS=SS+S(N1)
1170 NEXT N1
1180 FOR N1=1 TO AAA
1190 K(N1)=S(N1)/SS
1200 NEXT N1
1210 XX=0
1220 FOR N1=1 TO AAA
1230 X(N1)=(K(N1)*100)*(A(N1)+A6(N1)*15.9994)/A(N1)
1240 XX=XX+X(N1)
1250 NEXT N1
1260 FOR N1=1 TO AAA
1270 C(N1)=X(N1)*100/XX
1280 NEXT N1
1290 CLS
1300 LOCATE 3,10
1310 PRINT TAB(8)"Element";TAB(19)"Line";TAB(28)"K-ratio";TAB(41)"Weight percent";TAB(59)"Weight percent oxide"
1320 FOR N1=1 TO AAA
1330 LOCATE (5+N1),10:PRINT"";Z$(N1);TAB(20);L$(N1);TAB(29);
1340 PRINT USING"#.###";K(N1)
1350 LOCATE (5+N1),44:PRINT USING"###.###";K(N1)*100
1360 LOCATE (5+N1),63:PRINT USING"###.###";C(N1)
1370 NEXT N1
1380 LOCATE 22,32
1390 INPUT"Hard copy (y/n): ",HH$
1392 IF HH$="y" OR HH$="Y" GOTO 1400
1394 IF HH$="n" OR HH$="N" GOTO 1900
1400 CLS:' izpis rezultatov na linijski printer
1410 LOCATE 12,30
1450 LOCATE 13,22
1460 INPUT"Please type sample name: ",SX$
1470 IF UU$="E" OR UU$="e" GOTO 1490
1480 IF UU$="O" OR UU$="o" GOTO 1700
1490 LPRINT:LPRINT:LPRINT:LPRINT
1492 LPRINT CHR$(27)+"G";
1500 LPRINT TAB(25)"SEMIQUANTITATIVE ANALYSIS"
1505 LPRINT CHR$(27)+"H";
1510 LPRINT:LPRINT
1515 LPRINT TAB(30)"  Date: ";DATE$
1516 LPRINT TAB(30)"  Time: ";TIME$
1520 LPRINT TAB(30)"Sample: ";SX$
1530 LPRINT:LPRINT
1540 LPRINT TAB(16)"Accelerating voltage: ";V;" keV"
1550 LPRINT TAB(16)"          Tilt angle: ";INT((57.32484*T1*100+.5)/100);" degrees"
1560 LPRINT TAB(16)"      Take-off angle: ";INT((57.32484*D*100+.5)/100);" degrees"
1570 LPRINT TAB(16)"  Number of elements: ";AAA
1580 LPRINT:LPRINT
1590 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(27)"Int";TAB(36)"K-ratio";TAB(45)"Weight %";TAB(55)"Atomic %"
1600 LPRINT
1610 FOR N1=1 TO AAA
1620 LPRINT TAB(12)"";Z$(N1);TAB(20)"";L$(N1);TAB(24);
1630 LPRINT USING"######.###";A5(N1);
1640 LPRINT TAB(37);
1641 LPRINT USING"#.###";K(N1);
1642 LPRINT TAB(45);
1643 LPRINT USING"###.###";K(N1)*100;
1644 LPRINT TAB(55);
1645 LPRINT USING"###.###";G(N1)*100/GG
1655 NEXT N1
1660 LPRINT:LPRINT:GOTO 1900
1700 LPRINT:LPRINT:LPRINT:LPRINT
1705 LPRINT CHR$(27)+"G";
1710 LPRINT TAB(27)"SEMIQUANTIATIVE ANALYSIS"
1715 LPRINT CHR$(27)+"H";
1720 LPRINT:LPRINT
1725 LPRINT TAB(30)"  Date: ";DATE$
1727 LPRINT TAB(30)"  Time: ";TIME$
1730 LPRINT TAB(30)"Sample: ";SX$
1740 LPRINT:LPRINT
1750 LPRINT TAB(16)"Accelerating voltage: ";V;" keV"
1760 LPRINT TAB(16)"          Tilt angle: ";INT((57.32384*T1*100+.5)/100);" degrees"
1770 LPRINT TAB(16)"      Take-off angle: ";INT((57.32484*D*100+.5)/100);" degrees"
1780 LPRINT TAB(16)"  Number of elements: ";AAA
1790 LPRINT:LPRINT
1800 LPRINT TAB(10)"Element";TAB(19)"Line";TAB(26)"Int";TAB(35)"K-ratio";TAB(45);"Weight %";TAB(55)"Weight % oxide"
1810 LPRINT
1820 FOR N1=1 TO AAA
1830 LPRINT TAB(12)"";Z$(N1);TAB(20)"";L$(N1);TAB(22);
1840 LPRINT USING"######.###";A5(N1);
1841 LPRINT TAB(35);
1842 LPRINT USING"#.###";K(N1);
1843 LPRINT TAB(45);
1844 LPRINT USING"###.###";K(N1)*100;
1845 LPRINT TAB(58);
1846 LPRINT USING"###.###";C(N1)
1870 NEXT N1
1880 LPRINT:LPRINT
1900 CLS
1910 LOCATE 13,27:INPUT"Another calculation (y/n): ",DDD$
1920 IF DDD$="y" OR DDD$="Y" GOTO 65 ELSE 2000
2000 CLOSE:CLS
2010 OPEN"i",#5,"menu.dat"
2020 INPUT #5,XY999
2030 IF XY999=1 GOTO 2050
2040 IF XY999=0 GOTO 2060
2050 CLOSE:RUN"ms.exe":END
2060 CLOSE:SYSTEM:END
