50 ' Phi-Rho-Z curves
60 ' Written for IBM PC or compatible computer
70 ' Calc.method based on Brown and Parobek
80 ' Author:Henrik Kaker,4-10-1988
100 KEY OFF
101 OPEN"I",#1,"color.dat"
102 INPUT #1,X99
103 INPUT #1,Y99
104 INPUT #1,Z99
105 COLOR X99,Y99,Z99
110 CLS
120 LOCATE 3
125 T$="PHI (RHO - Z) CURVES"
126 GOSUB 3000
140 LOCATE 6,23
150 INPUT"Accelerating voltage (keV): ",E0
160 LOCATE 7,25
170 INPUT"Take-off angle (degrees): ",T
180 T=T*3.14159/180
185 LOCATE 8,23
190 INPUT"        Number of elements: ",AA
200 DIM Z(10),Z$(10),L(10),L$(10),C(10),F(10),M(10,10)
210 DIM R(10),S(10),K(10),D(10),AA(10)
211 DIM A(3,12),W(12),V(2,10)
220 GOSUB 2000
230 LOCATE 10,21
240 PRINT TAB(21)"Element";TAB(38)"Line";TAB(52)"Weight %"
290 FOR N=1 TO AA
300 LOCATE (11+N),24:INPUT"",Z$(N)
301 IF Z$(N)="C" OR Z$(N)="c" THEN Z(N)=6
302 IF Z$(N)="N" OR Z$(N)="n" THEN Z(N)=7
303 IF Z$(N)="O" OR Z$(N)="o" THEN Z(N)=8
304 IF Z$(N)="F" OR Z$(N)="f" THEN Z(N)=9
305 IF Z$(N)="Na" OR Z$(N)="NA" OR Z$(N)="na" THEN Z(N)=11
306 IF Z$(N)="Mg" OR Z$(N)="MG" OR Z$(N)="mg" THEN Z(N)=12
307 IF Z$(N)="Al" OR Z$(N)="AL" OR Z$(N)="al" THEN Z(N)=13
308 IF Z$(N)="Si" OR Z$(N)="SI" OR Z$(N)="si" THEN Z(N)=14
309 IF Z$(N)="S" OR Z$(N)="s" THEN Z(N)=16
310 IF Z$(N)="Cl" OR Z$(N)="CL" OR Z$(N)="cl" THEN Z(N)=17
311 IF Z$(N)="K" OR Z$(N)="k" THEN Z(N)=19
312 IF Z$(N)="Ca" OR Z$(N)="CA" OR Z$(N)="ca" THEN Z(N)=20
313 IF Z$(N)="Sc" OR Z$(N)="SC" OR Z$(N)="sc" THEN Z(N)=21
314 IF Z$(N)="Ti" OR Z$(N)="TI" OR Z$(N)="ti" THEN Z(N)=22
315 IF Z$(N)="V" OR Z$(N)="v" THEN Z(N)=23
316 IF Z$(N)="Cr" OR Z$(N)="CR" OR Z$(N)="cr" THEN Z(N)=24
317 IF Z$(N)="Mn" OR Z$(N)="MN" OR Z$(N)="mn" THEN Z(N)=25
318 IF Z$(N)="Fe" OR Z$(N)="FE" OR Z$(N)="fe" THEN Z(N)=26
319 IF Z$(N)="Co" OR Z$(N)="CO" OR Z$(N)="co" THEN Z(N)=27
320 IF Z$(N)="Ni" OR Z$(N)="NI" OR Z$(N)="ni" THEN Z(N)=28
321 IF Z$(N)="Cu" OR Z$(N)="CU" OR Z$(N)="cu" THEN Z(N)=29
322 IF Z$(N)="Zn" OR Z$(N)="ZN" OR Z$(N)="zn" THEN Z(N)=30
323 IF Z$(N)="Ga" OR Z$(N)="GA" OR Z$(N)="ga" THEN Z(N)=31
324 IF Z$(N)="Ge" OR Z$(N)="GE" OR Z$(N)="ge" THEN Z(N)=32
325 IF Z$(N)="As" OR Z$(N)="AS" OR Z$(N)="as" THEN Z(N)=33
326 IF Z$(N)="Se" OR Z$(N)="SE" OR Z$(N)="se" THEN Z(N)=34
327 IF Z$(N)="Br" OR Z$(N)="BR" OR Z$(N)="br" THEN Z(N)=35
328 IF Z$(N)="Rb" OR Z$(N)="RB" OR Z$(N)="rb" THEN Z(N)=37
329 IF Z$(N)="Sr" OR Z$(N)="SR" OR Z$(N)="sr" THEN Z(N)=38
330 IF Z$(N)="Y" OR Z$(N)="y" THEN Z(N)=39
331 IF Z$(N)="Zr" OR Z$(N)="ZR" OR Z$(N)="zr" THEN Z(N)=40
332 IF Z$(N)="Nb" OR Z$(N)="NB" OR Z$(N)="nb" THEN Z(N)=41
333 IF Z$(N)="Mo" OR Z$(N)="MO" OR Z$(N)="mo" THEN Z(N)=42
334 IF Z$(N)="Tc" OR Z$(N)="TC" OR Z$(N)="tc" THEN Z(N)=43
335 IF Z$(N)="Ru" OR Z$(N)="RU" OR Z$(N)="ru" THEN Z(N)=44
336 IF Z$(N)="Rh" OR Z$(N)="RH" OR Z$(N)="rh" THEN Z(N)=45
337 IF Z$(N)="Pd" OR Z$(N)="PD" OR Z$(N)="pd" THEN Z(N)=46
338 IF Z$(N)="Ag" OR Z$(N)="AG" OR Z$(N)="ag" THEN Z(N)=47
339 IF Z$(N)="Cd" OR Z$(N)="CD" OR Z$(N)="cd" THEN Z(N)=48
340 IF Z$(N)="In" OR Z$(N)="IN" OR Z$(N)="in" THEN Z(N)=49
341 IF Z$(N)="Sn" OR Z$(N)="SN" OR Z$(N)="sn" THEN Z(N)=50
342 IF Z$(N)="Sb" OR Z$(N)="SB" OR Z$(N)="sb" THEN Z(N)=51
343 IF Z$(N)="Te" OR Z$(N)="TE" OR Z$(N)="te" THEN Z(N)=52
344 IF Z$(N)="I" OR Z$(N)="i" THEN Z(N)=53
345 IF Z$(N)="Cs" OR Z$(N)="CS" OR Z$(N)="cs" THEN Z(N)=55
346 IF Z$(N)="Ba" OR Z$(N)="BA" OR Z$(N)="ba" THEN Z(N)=56
347 IF Z$(N)="La" OR Z$(N)="LA" OR Z$(N)="la" THEN Z(N)=57
348 IF Z$(N)="Ce" OR Z$(N)="CE" OR Z$(N)="ce" THEN Z(N)=58
349 IF Z$(N)="Pr" OR Z$(N)="PR" OR Z$(N)="pr" THEN Z(N)=59
350 IF Z$(N)="Nd" OR Z$(N)="ND" OR Z$(N)="nd" THEN Z(N)=60
351 IF Z$(N)="Pm" OR Z$(N)="PM" OR Z$(N)="pm" THEN Z(N)=61
352 IF Z$(N)="Sm" OR Z$(N)="SM" OR Z$(N)="sm" THEN Z(N)=62
353 IF Z$(N)="Eu" OR Z$(N)="EU" OR Z$(N)="eu" THEN Z(N)=63
354 IF Z$(N)="Gd" OR Z$(N)="GD" OR Z$(N)="gd" THEN Z(N)=64
355 IF Z$(N)="Tb" OR Z$(N)="TB" OR Z$(N)="tb" THEN Z(N)=65
356 IF Z$(N)="Dy" OR Z$(N)="DY" OR Z$(N)="dy" THEN Z(N)=66
357 IF Z$(N)="Ho" OR Z$(N)="HO" OR Z$(N)="ho" THEN Z(N)=67
358 IF Z$(N)="Er" OR Z$(N)="ER" OR Z$(N)="er" THEN Z(N)=68
359 IF Z$(N)="Tm" OR Z$(N)="TM" OR Z$(N)="tm" THEN Z(N)=69
360 IF Z$(N)="Yb" OR Z$(N)="YB" OR Z$(N)="yb" THEN Z(N)=70
361 IF Z$(N)="Lu" OR Z$(N)="LU" OR Z$(N)="lu" THEN Z(N)=71
362 IF Z$(N)="Hf" OR Z$(N)="HF" OR Z$(N)="hf" THEN Z(N)=72
363 IF Z$(N)="Ta" OR Z$(N)="TA" OR Z$(N)="ta" THEN Z(N)=73
364 IF Z$(N)="W" OR Z$(N)="w" THEN Z(N)=74
365 IF Z$(N)="Re" OR Z$(N)="RE" OR Z$(N)="re" THEN Z(N)=75
366 IF Z$(N)="Os" OR Z$(N)="OS" OR Z$(N)="os" THEN Z(N)=76
367 IF Z$(N)="Ir" OR Z$(N)="IR" OR Z$(N)="ir" THEN Z(N)=77
368 IF Z$(N)="Pt" OR Z$(N)="PT" OR Z$(N)="pt" THEN Z(N)=78
369 IF Z$(N)="Au" OR Z$(N)="AU" OR Z$(N)="au" THEN Z(N)=79
370 IF Z$(N)="Hg" OR Z$(N)="HG" OR Z$(N)="hg" THEN Z(N)=80
371 IF Z$(N)="Tl" OR Z$(N)="TL" OR Z$(N)="tl" THEN Z(N)=81
372 IF Z$(N)="Pb" OR Z$(N)="PB" OR Z$(N)="pb" THEN Z(N)=82
373 IF Z$(N)="Bi" OR Z$(N)="BI" OR Z$(N)="bi" THEN Z(N)=83
374 IF Z$(N)="U" OR Z$(N)="u" THEN Z(N)=92
375 IF Z$(N)="P" OR Z$(N)="p" THEN Z(N)=15
380 LOCATE (11+N),39:INPUT"",L$(N)
382 L(N)=0
384 IF L$(N)="K" OR L$(N)="k" THEN L(N)=1
385 IF L$(N)="L" OR L$(N)="l" THEN L(N)=2
386 IF L$(N1)="M" OR L$(N)="m" THEN L(N)=3
390 LOCATE(11+N),53:INPUT"",C(N)
392 C(N)=C(N)/100
400 NEXT N
402 N=N-1
404 PRINT
406 FOR I=1 TO N
408 ' Calc F(I)=ABS Edge,M(I,J)=Mass Abs Coeff
410 L0=L(I)*L(I)
412 Z0=LOG(Z(I))
414 F(I)=EXP(A(1,L0)+A(2,L0)*Z0+A(3,L0)*Z0*Z0)
416 L1=L(I)+9
418 E=EXP(A(1,L1)+A(2,L1)*Z0+A(3,L1)*Z0*Z0)
420 FOR J=1 TO N
422 Z0=LOG(Z(J))
424 U(1)=EXP(-.0045522*Z0*Z0-.0068535*Z0+1.07018)
426 U(2)=2.73
430 U(3)=2.6
440 U(4)=2.22
450 IF Z<42 GOTO 470
460 U(2)=EXP(-.113159*Z0*Z0+.836883*Z0-.545969)
470 L=1
480 IF L>=10 GOTO 530
490 E1=EXP(A(1,L)+A(2,L)*Z0+A(3,L)*Z0*Z0)
500 IF E>E1 GOTO 530
510 L=L+1
520 GOTO 480
530 T0=W(V(2,L))*Z0*Z0+W(V(2,L)+4)*Z0+W(V(2,L)+8)
540 T0=EXP((T0)/V(1,L))
550 M(J,I)=T0*(12.398/E)^U(V(2,L))
551 ' J=Absorber,I=Emitter
552 ' This is the FRAME Mass Abs Function
553 ' Use only for 1 keV <E<12 keV
560 NEXT J
900 R(I)=24.487*E0*F(I)^.428/Z(I)^1.259
905 R(I)=R(I)*(1+1/EXP(.0015*Z(I)))
910 S(I)=2.7846*Z(I)^(-.1911)
920 K(I)=.5409/F(I)^1.228
925 K(I)=K(I)*(1+(.05199*Z(I)^.7)/EXP(.0002*Z(I)*Z(I)))
930 K(I)=K(I)/(E0-F(I))^((15.6578/F(I))^.2505)
940 D(I)=.5945*E0^(1.42)*Z(I)^(.26)
950 D(I)=D(I)*(E0-F(I))^(2.111*(1.84/F(I))^.325)
960 NEXT I
970 X9=12
980 Y9=3
990 DIM P(200),Q(200)
993 LOCATE 24,23
1000 INPUT"Display curves for which element: ",Z$(N)
1002 FOR I=1 TO N
1003 IF Z$(I)=Z$(N) GOTO 1005
1004 NEXT I
1005 CLS
1010 COLOR X99,Y99,Z99
1020 Q0=0
1021 P0=0
1022 SCREEN 2,0,0
1023 LINE (100,25)-(600,170),,B
1026 FOR C=1 TO 200
1027 R1=C*X9
1028 R2=R1+R(I)
1030 U0=0
1032 FOR J=1 TO N
1034 U0=U0+C(J)*M(J,I)
1035 NEXT J
1037 E9=EXP(-(K(I)*R2)^S(I))
1038 P1=C(I)*D(I)*K(I)*S(I)*(K(I)*R2)^(S(I)-1)*E9
1040 P0=P0+P1
1041 Q1=P1*EXP(-R1*U0/SIN(T)/1000000!)
1042 Q0=Q0+Q1
1044 P(C)=1000*P1/Y9
1045 Q(C)=1000*Q1/Y9
1046 'x-scale
1047 FOR X=100 TO 600 STEP (600-100)/10
1048 LINE (X,170)-(X,167):NEXT X
1049 LOCATE 23,100/8:PRINT"0":LOCATE 23,565/8:PRINT"";INT(200*X9+.5)
1050 'y-scale
1051 FOR Y=25 TO 170 STEP (170-25)/10
1052 LINE (100,Y)-(103,Y):NEXT Y
1053 L$="Depth (Rho - Z) in ug/cm^2":LOCATE 23,31:PRINT L$
1054 T$="Intensity":ROW=13-LEN(T$)/2
1055 FOR CHAR=1 TO LEN(T$)
1056 LOCATE ROW,10
1057 PRINT MID$(T$,CHAR,1);
1058 ROW=ROW+1
1059 NEXT CHAR
1060 LOCATE 1,31:PRINT"Phi (Rho - Z) curve for:";Z$(N)
1084 XS=(600-100)/200
1085 YS=(170-25)/10000
1086 X=C*XS+100
1088 Y=170-YS*P(C):IF Y<=25 THEN Y=25
1089 Z=170-YS*Q(C):IF Z<=25 THEN Z=25
1090 PSET (X,Y)
1092 PSET (X,Z)
1100 NEXT C
1101 Y1=0
1110 A$=INKEY$:IF A$="" GOTO 1110
1111 Y1=0
1200 CLS:SCREEN 0,0,0
1210 COLOR X99,Y99,Z99
1215 CLS
1260 LOCATE 3,21
1270 PRINT"Horizontal axis: 0 - ";INT(200*X9+.5);" ug/cm^2"
1280 LOCATE 4,21
1290 PRINT"Emitted fraction: ";INT(10000*Q0/P0+.5)/100;" %"
1300 MENOPT$(1)="A. Next element"
1310 MENOPT$(2)="B. Change scale"
1320 MENOPT$(3)="C. Main menu"
1330 LAST=3
1340 FOR CHOICE=1 TO LAST
1345 ROW%(CHOICE)=3*CHOICE+7:COL%(CHOICE)=30:NEXT
1350 GOSUB 7500
1360 ON PICK GOTO 1400,1410,9999
1400 CLS:GOTO 993
1410 LOCATE 20,22
1420 INPUT"Horizontal scale: ",C1
1430 X9=C1/200
1440 LOCATE 21,24
1450 INPUT"Vertical scale: ",Y9
1460 CLS:GOTO 993
2000 ' Load data arrays
2020 FOR K=1 TO 12
2030 FOR J=1 TO 3
2040 READ A(J,K)
2050 NEXT J
2060 NEXT K
2070 FOR J=1 TO 2
2072 FOR K=1 TO 10
2074 READ V(J,K)
2076 NEXT K
2078 NEXT J
2080 FOR J=1 TO 12
2085 READ W(J)
2090 NEXT J
2100 DATA -5.5091,2.423,-3.97931E-2
2110 DATA -9.03526,2.82526,-.033916
2120 DATA -10.2505,3.32315,-8.65397E-2
2130 DATA -12.0025,4.31172,-.228343
2140 DATA 11.5803,-7.838,1.25179
2150 DATA 3.33802,-4.14925,.834903
2160 DATA -3.15348,-.979241,.442217
2170 DATA -8.03561,.931913,.25141
2180 DATA -7.4243,.688906,.272951
2190 DATA -5.17083,2.21859,-1.88608E-2
2200 DATA -9.75836,3.29533,-.123941
2210 DATA -20.0833,6.84662,-.47555
2220 DATA 1,1,1.17,1.63,1,1.16,1.4,1.621,1.783,1
2230 DATA 1,2,2,2,3,3,3,3,3,4
2240 DATA -.232229,-.254471,.256216,1.35917
2250 DATA 4.07005,4.76925,1.15119,-9.49212
2260 DATA -6.22075,-10.3788,-5.68485,18.6408
2300 RETURN
3000 ' Print title & center
3010 COL=(81-LEN(T$))/2
3020 LOCATE ,COL
3030 PRINT T$
3040 RETURN
7500 'menu generation subroutine
7510 PICK=1:PICK$=""
7520 'create menu
7530 FOR CHOICE=1 TO LAST
7540 LOCATE ROW%(CHOICE),COL%(CHOICE)
7545 IF X99=7 THEN 7550
7548 IF X99=15 THEN 7553
7550 IF PICK=CHOICE THEN COLOR 0,7:GOTO 7560
7553 IF PICK=CHOICE THEN COLOR 1,15
7560 PRINT MENOPT$(CHOICE)
7565 IF X99=7 THEN 7570
7568 IF X99=15 THEN 7573
7570 COLOR 7,0:GOTO 7580
7573 COLOR 15,1
7580 NEXT
7590 IF PICK$=CHR$(27) GOTO 7760
7600 ' collect input
7610 PICK$=INKEY$:IF PICK$="" GOTO 7610
7620 ASCII=ASC(PICK$)
7630 IF ASCII=13 GOTO 7760
7640 IF PICK$="" THEN PICK=PICK+1:IF PICK>LAST THEN PICK=1:GOTO 7520
7650 IF ASCII>=97 AND ASCII<=122 THEN PICK$=CHR$(ASC(PICK$)-32)
7660 IF LEN(PICK$)=1 THEN 7720 ELSE 7670
7670 PICK$=RIGHT$(PICK$,1)
7680 ASCII=ASC(PICK$)
7690 IF ASCII=72 THEN PICK=PICK-1:IF PICK=0 THEN PICK=LAST
7700 IF ASCII=80 THEN PICK=PICK+1:IF PICK>LAST THEN PICK=1
7710 GOTO 7520
7720 FOR CHOICE=1 TO LAST
7730 IF PICK$=LEFT$(MENOPT$(CHOICE),1) THEN PICK=CHOICE
7740 NEXT
7750 GOTO 7520
7760 RETURN
9999 CLOSE:CLS
10000 OPEN"i",#5,"menu.dat"
10010 INPUT #5,XY999
10020 IF XY999=1 GOTO 10050
10030 IF XY999=0 GOTO 10060
10050 CLOSE:RUN"ms.exe":END
10060 CLOSE:SYSTEM:END
