300 'Bence-Albee program for 20 kV-38.5 degrees
305 CLEAR
310 KEY OFF
320 OPEN"i",#1,"color.dat"
330 INPUT #1,X999
340 INPUT #1,Y999
350 INPUT #1,Z999
360 COLOR X999,Y999,Z999
370 CLS
380 DIM A(36,36),Z$(15),Z(15),A5(15),BCU(15),A6(15),BCS(15),W1(15),B1(15)
390 DIM K0(15),K(15),CC$(15),B(36,36)
410 'Bence-Albee program for 15 kV - 38.5 degrees
420 CLS
430 T$="BENCE-ALBEE CORRECTION PROGRAM"
440 LOCATE 5,(80-LEN(T$))/2
450 PRINT T$
460 LOCATE 10,30:INPUT"Number of elements: ",AA
470 LOCATE 12,22:INPUT"Pure oxide standards (y/n): ",XX$
475 CLS
480 LOCATE 3,6:PRINT"Element";TAB(19)"Int.for sample";TAB(39)"BCF";TAB(47)"Int.for standard";TAB(68)"BCF"
490 FOR I=1 TO AA
500 LOCATE (4+I),8:INPUT"",Z$(I)
501 IF Z$(I)="O" OR Z$(I)="o" THEN Z(I)=1
502 IF Z$(I)="C" OR Z$(I)="c" THEN Z(I)=2
503 IF Z$(I)="F" OR Z$(I)="f" THEN Z(I)=3
504 IF Z$(I)="Na" OR Z$(I)="na" OR Z$(I)="NA" THEN Z(I)=4
505 IF Z$(I)="Al" OR Z$(I)="al" OR Z$(I)="AL" THEN Z(I)=6
506 IF Z$(I)="Mg" OR Z$(I)="mg" OR Z$(I)="MG" THEN Z(I)=5
507 IF Z$(I)="Si"OR Z$(I)="si" OR Z$(I)="SI" THEN Z(I)=7
508 IF Z$(I)="P" OR Z$(I)="p" THEN Z(I)=8
509 IF Z$(I)="S" OR Z$(I)="s" THEN Z(I)=9
510 IF Z$(I)="Cl" OR Z$(I)="cl" OR Z$(I)="CL" THEN Z(I)=10
511 IF Z$(I)="K" OR Z$(I)="k" THEN Z(I)=11
512 IF Z$(I)="Ca" OR Z$(I)="ca" OR Z$(I)="CA" THEN Z(I)=12
513 IF Z$(I)="Ti" OR Z$(I)="ti" OR Z$(I)="TI" THEN Z(I)=13
514 IF Z$(I)="Cr" OR Z$(I)="cr" OR Z$(I)="CR" THEN Z(I)=14
515 IF Z$(I)="Mn" OR Z$(I)="mn" OR Z$(I)="MN" THEN Z(I)=15
516 IF Z$(I)="Fe" OR Z$(I)="fe" OR Z$(I)="FE" THEN Z(I)=16
517 IF Z$(I)="Co" OR Z$(I)="co" OR Z$(I)="CO" THEN Z(I)=17
518 IF Z$(I)="Ni" OR Z$(I)="ni" OR Z$(I)="NI" THEN Z(I)=18
519 IF Z$(I)="Cu" OR Z$(I)="cu" OR Z$(I)="CU" THEN Z(I)=19
520 IF Z$(I)="Zn" OR Z$(I)="zn" OR Z$(I)="ZN" THEN Z(I)=20
521 IF Z$(I)="Rb" OR Z$(I)="rb" OR Z$(I)="RB" THEN Z(I)=21
522 IF Z$(I)="Sr" OR Z$(I)="sr" OR Z$(I)="SR" THEN Z(I)=22
523 IF Z$(I)="Y" OR Z$(I)="y" THEN Z(I)=23
524 IF Z$(I)="Zr" OR Z$(I)="zr" OR Z$(I)="ZR" THEN Z(I)=24
525 IF Z$(I)="La" OR Z$(I)="la" OR Z$(I)="LA" THEN Z(I)=26
526 IF Z$(I)="Ce" OR Z$(I)="ce" OR Z$(I)="CE" THEN Z(I)=27
527 IF Z$(I)="Pr" OR Z$(I)="pr" OR Z$(I)="PR" THEN Z(I)=28
528 IF Z$(I)="Nd" OR Z$(I)="nd" OR Z$(I)="ND" THEN Z(I)=29
529 IF Z$(I)="Sm" OR Z$(I)="sm" OR Z$(I)="SM" THEN Z(I)=30
530 IF Z$(I)="Gd" OR Z$(I)="gd" OR Z$(I)="GD" THEN Z(I)=31
531 IF Z$(I)="Dy" OR Z$(I)="dy" OR Z$(I)="DY" THEN Z(I)=32
532 IF Z$(I)="Er" OR Z$(I)="er" OR Z$(I)="ER" THEN Z(I)=33
533 IF Z$(I)="Hf" OR Z$(I)="hf" OR Z$(I)="HF" THEN Z(I)=34
534 IF Z$(I)="Th" OR Z$(I)="th" OR Z$(I)="TH" THEN Z(I)=35
535 IF Z$(I)="U" OR Z$(I)="u" THEN Z(I)=36
536 IF Z$(I)="Ba" OR Z$(I)="ba" OR Z$(I)="BA" THEN Z(I)=25
540 LOCATE (4+I),21:INPUT"",A5(I)
550 LOCATE (4+I),39:INPUT"",BCU(I)
560 LOCATE (4+I),49:INPUT"",A6(I)
570 LOCATE (4+I),68:INPUT"",BCS(I)
580 NEXT I
590 IF XX$="N" OR XX$="n" THEN 600 ELSE 700
600 CLS
610 T$="Input data for mixed (not pure oxid) standards."
620 LOCATE 3,(80-LEN(T$))/2
630 PRINT T$
640 LOCATE 5,14:PRINT"Element";TAB(34)"Weight percent";TAB(60)"Beta"
650 FOR I=1 TO AA
660 LOCATE (6+I),17:PRINT Z$(I)
670 LOCATE (6+I),37:INPUT"",W1(I):W1(I)=W1(I)/100
680 LOCATE (6+I),60:INPUT"",B1(I)
690 NEXT I
700 'Method Bence-Albee
710 'First aprox.
720 IF XX$="y" OR XX$="Y" THEN 725 ELSE 800
725 S=0
730 FOR I=1 TO AA
740 A5(I)=A5(I)*(1/BCU(I))
750 A6(I)=A6(I)*(1/BCS(I))
760 K0(I)=A5(I)/A6(I)
770 S=S+K0(I)
780 NEXT I
785 GOTO 1000
790 'Sample composition
800 S=0
810 FOR I=1 TO AA
820 A5(I)=A5(I)*(1/BCU(I))
830 A6(I)=A6(I)*(1/BCS(I))
840 K0(I)=A5(I)/A6(I)*W1(I)/B1(I)
850 S=S+K0(I)
860 NEXT I
1000 'Alfa matrix for 20 kV-38.5 degrees
1020 DATA 1.00,2.44,1.11,1.73,2.23,2.56,2.93,3.45,3.93,11.74,16.30,17.37,21.03,2.35,2.77,3.12,3.45,3.94,4.38,4.96,12.14,13.43,14.00,15.22,4.46,4.50,4.72,4.95,5.14,5.54,6.06,6.49,6.92,8.25,16.44,18.23
1021 DATA 1.20,1.00,1.61,3.75,5.48,7.34,8.68,11.97,13.82,56.48,4.40,4.16,4.29,6.13,7.92,9.36,11.00,13.14,15.70,18.72,40.80,32.85,26.12,29.05,12.09,11.60,12.33,13.10,13.85,15.42,17.49,19.22,20.99,27.67,66.67,75.72
1022 DATA 11.38,10.59,1.00,3.55,5.37,6.81,7.80,8.96,9.70,5.70,9.67,11.80,16.00,20.32,23.02,3.81,3.89,4.21,4.29,4.55,6.92,8.21,9.19,10.38,3.62,3.97,4.09,4.23,4.31,4.49,4.72,4.92,5.12,6.07,10.06,10.94
1023 DATA 2.16,1.90,2.57,1.00,1.30,1.45,1.60,1.70,1.81,1.36,1.87,2.15,2.55,3.20,3.66,4.12,4.63,5.24,4.90,3.85,1.56,1.75,1.85,2.01,3.00,3.06,3.34,3.53,3.71,1.25,1.30,1.34,1.39,1.57,2.41,2.58
1024 DATA 1.52,1.35,1.74,2.55,1.00,1.08,1.17,1.22,1.29,1.01,1.31,1.48,1.68,2.01,2.27,2.52,2.78,3.11,3.39,3.76,1.10,1.21,1.27,1.36,2.63,2.67,2.35,2.48,2.25,2.44,2.65,1.00,1.02,1.12,1.61,1.71
1025 DATA 1.29,1.17,1.43,1.92,2.10,1.00,1.06,1.09,1.14,0.94,1.15,1.27,1.39,1.60,1.78,1.94,2.10,2.32,2.49,2.72,1.00,1.08,1.12,1.18,2.42,2.40,2.53,2.33,2.43,2.23,2.10,2.27,2.44,1.04,1.45,1.54
1026 DATA 1.15,1.06,1.23,1.57,1.71,1.83,1.00,1.00,1.04,0.89,1.04,1.13,1.19,1.33,1.44,1.55,1.65,1.80,1.90,2.04,0.91,0.96,0.99,1.03,1.80,1.80,1.89,1.98,2.05,2.21,2.08,1.90,1.81,2.13,1.20,1.26
1027 DATA 1.10,1.04,1.15,1.38,1.49,1.56,1.64,1.00,1.02,0.90,1.01,1.08,1.12,1.21,1.29,1.37,1.44,1.55,1.61,1.71,2.42,2.53,0.96,1.00,1.58,1.57,1.63,1.70,1.76,1.87,1.99,1.89,2.02,1.82,1.16,1.21
1028 DATA 1.05,1.00,1.08,1.25,1.33,1.38,1.44,1.50,1.00,0.88,0.97,1.02,1.04,1.10,1.15,1.21,1.25,1.33,1.36,1.43,2.11,2.20,1.96,2.04,1.30,1.30,1.34,1.39,1.42,1.50,1.57,1.66,1.75,1.59,1.01,1.05
1029 DATA 1.13,1.09,1.13,1.27,1.34,1.38,1.43,1.48,1.52,1.00,1.04,1.09,1.09,1.14,1.15,1.20,1.23,1.30,1.30,1.35,1.81,1.87,1.91,1.96,1.20,1.23,1.26,1.30,1.32,1.37,1.42,1.48,1.54,1.71,0.99,1.02
1030 DATA 1.06,1.03,1.04,1.12,1.17,1.18,1.21,1.22,1.25,1.55,1.00,1.01,0.99,1.01,1.01,1.04,1.04,1.09,1.08,1.10,1.33,1.37,1.38,1.41,0.99,1.00,1.02,1.05,1.06,1.08,1.10,1.13,1.16,1.26,0.88,0.90
1031 DATA 1.03,1.00,1.00,1.06,1.11,1.11,1.14,1.14,1.16,1.38,1.45,1.00,0.94,0.95,0.94,0.97,0.97,1.02,1.00,1.02,1.17,1.20,1.21,1.23,0.89,0.91,0.92,0.94,0.95,0.97,0.98,1.00,1.02,1.08,1.21,0.96
1032 DATA 1.07,1.05,1.04,1.08,1.12,1.11,1.14,1.13,1.15,1.24,1.29,1.31,1.00,0.93,0.92,0.95,0.95,0.99,0.96,0.98,1.06,1.09,1.10,1.12,0.90,0.89,0.90,0.88,0.88,0.89,0.90,0.91,0.92,0.96,1.11,1.15
1033 DATA 1.09,1.07,1.05,1.08,1.12,1.11,1.13,1.11,1.13,1.15,1.19,1.21,1.17,1.00,0.96,0.91,0.91,0.94,0.92,0.93,1.00,1.01,1.03,1.04,1.05,0.89,0.90,0.90,0.90,0.86,0.82,0.83,0.84,0.88,1.09,1.07
1034 DATA 1.12,1.10,1.08,1.11,1.14,1.13,1.15,1.13,1.15,1.15,1.18,1.21,1.17,1.02,1.00,0.99,0.89,0.93,0.91,0.93,0.99,1.01,1.02,1.03,1.08,1.10,1.03,0.91,0.90,0.90,0.85,0.86,0.81,0.84,1.01,1.04
1035 DATA 1.11,1.09,1.07,1.10,1.13,1.12,1.13,1.12,1.13,1.12,1.14,1.17,1.13,1.15,0.99,1.00,0.96,0.88,0.87,0.88,0.96,0.98,0.99,1.00,1.06,1.07,1.05,1.00,1.00,0.88,0.86,0.82,0.82,0.79,0.95,0.97
1036 DATA 1.13,1.11,1.09,1.12,1.15,1.13,1.15,1.13,1.15,1.12,1.15,1.17,1.12,1.14,1.14,1.02,1.00,0.99,0.84,0.86,0.96,0.98,0.99,1.00,1.02,1.04,1.05,1.07,1.03,0.98,0.87,0.86,0.81,0.77,0.93,0.95
1037 DATA 1.11,1.09,1.06,1.09,1.12,1.11,1.12,1.10,1.11,1.08,1.10,1.13,1.08,1.09,1.09,1.11,0.97,1.00,0.92,0.80,0.93,0.95,0.96,0.97,0.97,0.98,0.99,1.00,1.00,0.97,0.92,0.83,0.83,0.79,0.88,0.89
1038 DATA 1.16,1.14,1.11,1.14,1.17,1.15,1.17,1.15,1.16,1.12,1.14,1.16,1.12,1.12,1.11,1.13,1.12,1.04,1.00,0.95,0.96,0.97,0.99,1.00,0.97,0.99,1.00,1.01,1.01,1.00,0.97,0.93,0.85,0.79,0.88,0.90
1039 DATA 1.16,1.15,1.12,1.14,1.17,1.16,1.17,1.15,1.16,1.12,1.13,1.16,1.11,1.11,1.09,1.11,1.10,1.13,1.00,1.00,0.96,0.97,0.99,1.00,0.95,0.97,0.98,0.99,0.98,0.98,0.97,0.95,0.91,0.85,0.87,0.88
1040 DATA 1.38,1.29,1.42,1.72,1.85,1.98,1.21,1.19,1.24,1.06,1.19,1.29,1.34,1.47,1.54,1.65,1.74,1.88,1.96,2.09,1.00,1.05,1.10,1.14,1.88,1.96,2.05,2.15,2.23,2.12,2.27,2.09,1.99,1.30,1.30,1.36
1041 DATA 1.30,1.21,1.33,1.61,1.73,1.84,1.14,1.12,1.17,1.01,1.13,1.22,1.26,1.38,1.44,1.53,1.61,1.74,1.80,1.92,2.13,1.00,1.04,1.08,1.71,1.77,1.85,1.93,2.00,2.14,2.03,1.87,1.78,2.01,1.20,1.26
1042 DATA 1.24,1.17,1.26,1.49,1.59,1.67,1.74,1.10,1.14,0.98,1.09,1.17,1.19,1.28,1.33,1.42,1.48,1.59,1.64,1.74,2.44,0.96,1.00,1.03,1.58,1.62,1.69,1.76,1.82,1.94,2.06,1.96,1.82,1.84,1.16,1.21
1043 DATA 1.20,1.13,1.21,1.42,1.52,1.58,1.65,1.07,1.10,0.97,1.06,1.13,1.15,1.23,1.27,1.35,1.40,1.50,1.53,1.62,2.22,2.27,0.97,1.00,1.46,1.50,1.56,1.62,1.66,1.76,1.87,1.78,1.89,1.67,1.09,1.13
1044 DATA 1.36,1.31,1.30,1.32,1.38,1.34,1.38,1.34,1.38,1.44,1.49,1.52,1.20,1.14,1.13,1.15,1.14,1.18,1.14,1.15,1.20,1.22,1.24,1.26,1.00,1.03,1.03,1.04,1.04,1.02,1.02,1.03,1.04,1.07,1.21,1.26
1045 DATA 1.32,1.29,1.26,1.30,1.35,1.32,1.35,1.32,1.35,1.38,1.43,1.46,1.18,1.15,1.10,1.12,1.11,1.15,1.11,1.12,1.15,1.17,1.20,1.21,0.97,1.00,1.01,1.01,1.01,0.99,0.99,0.99,1.00,1.03,1.16,1.21
1046 DATA 1.32,1.29,1.26,1.29,1.34,1.31,1.35,1.31,1.34,1.36,1.40,1.43,1.18,1.15,1.10,1.12,1.10,1.14,1.10,1.11,1.13,1.15,1.17,1.19,0.96,0.99,1.00,1.01,1.01,0.99,0.97,0.97,0.98,1.01,1.20,1.17
1047 DATA 1.31,1.28,1.25,1.28,1.33,1.30,1.33,1.30,1.33,1.34,1.37,1.41,1.36,1.15,1.11,1.11,1.09,1.13,1.09,1.09,1.11,1.13,1.15,1.17,0.95,0.98,0.99,1.00,1.00,0.98,0.95,0.95,0.96,0.98,1.16,1.13
1048 DATA 1.33,1.30,1.27,1.30,1.35,1.32,1.35,1.31,1.34,1.34,1.37,1.41,1.35,1.16,1.13,1.12,1.10,1.14,1.09,1.10,1.11,1.13,1.15,1.16,0.96,0.98,0.99,1.00,1.00,0.99,0.97,0.95,0.95,0.97,1.19,1.17
1049 DATA 1.36,1.33,1.30,1.32,1.37,1.34,1.37,1.33,1.36,1.34,1.37,1.41,1.35,1.18,1.16,1.17,1.11,1.15,1.10,1.11,1.11,1.13,1.15,1.16,1.21,1.15,1.00,1.01,1.01,1.00,0.99,0.97,0.95,0.96,1.14,1.17
1050 DATA 1.40,1.37,1.34,1.36,1.41,1.38,1.41,1.37,1.39,1.36,1.38,1.42,1.36,1.38,1.19,1.20,1.17,1.17,1.12,1.12,1.12,1.14,1.16,1.17,1.22,1.21,1.15,1.16,1.02,1.01,1.00,0.97,0.97,0.96,1.11,1.14
1051 DATA 1.43,1.40,1.36,1.38,1.43,1.40,1.43,1.39,1.41,1.36,1.39,1.42,1.36,1.37,1.21,1.23,1.20,1.23,1.13,1.13,1.12,1.14,1.16,1.18,1.19,1.22,1.20,1.22,1.15,1.02,1.01,1.00,0.97,0.95,1.08,1.11
1052 DATA 1.45,1.42,1.38,1.40,1.45,1.42,1.45,1.41,1.43,1.37,1.39,1.43,1.36,1.37,1.35,1.24,1.22,1.25,1.19,1.14,1.13,1.15,1.17,1.18,1.17,1.19,1.21,1.22,1.19,1.13,1.01,1.01,1.00,0.98,1.06,1.08
1053 DATA 1.47,1.43,1.40,1.42,1.46,1.43,1.46,1.41,1.44,1.37,1.39,1.43,1.36,1.35,1.33,1.35,1.34,1.27,1.21,1.20,1.13,1.15,1.18,1.19,1.13,1.16,1.17,1.18,1.18,1.18,1.10,1.09,1.01,1.00,1.03,1.04
1054 DATA 1.54,1.47,1.47,1.52,1.61,1.56,1.63,1.60,1.66,1.94,1.31,1.39,1.32,1.30,1.30,1.34,1.33,1.40,1.36,1.39,1.60,1.63,1.69,1.70,1.17,1.21,1.24,1.27,1.28,1.31,1.33,1.37,1.41,1.50,1.00,1.02
1055 DATA 1.54,1.47,1.47,1.51,1.59,1.55,1.61,1.57,1.63,1.85,1.31,1.39,1.32,1.29,1.29,1.33,1.32,1.38,1.33,1.35,1.52,1.55,1.60,1.62,1.14,1.18,1.20,1.23,1.23,1.26,1.27,1.30,1.34,1.42,0.98,1.00
1060 FOR X=1 TO 36
1070 FOR Y=1 TO 36
1080 READ A(X,Y)
1090 NEXT Y
1100 NEXT X
1110 'Weight percent
1120 S1=0:B(I,J)=0
1130 FOR I=1 TO AA
1140 B=0
1150 FOR J=1 TO AA
1160 B(I,J)=K0(I)*A(Z(I),Z(J))
1170 B=B+B(I,J)
1180 NEXT J
1190 K(I)=K0(I)*(B/S)
1200 S1=S1+K(I)
1210 NEXT I
1220 'Iteration
1230 IF (S1-S)<.00001 THEN 1300 ELSE 1240
1240 IF S1>1 THEN 1300 ELSE 1245
1245 S=0:S=S1
1250 FOR I=1 TO AA
1260 K0(I)=0
1270 K0(I)=K(I)
1280 NEXT I
1290 GOTO 1110
1300 'Printer
1305 CLS
1310 LOCATE 3,10
1320 PRINT TAB(14)"Oxide";TAB(32)"K-ratio";TAB(52)"Weight percent"
1340 FOR I=1 TO AA
1341 IF Z(I)=1 THEN CC$(I)="O"
1342 IF Z(I)=2 THEN CC$(I)="CO2"
1343 IF Z(I)=3 THEN CC$(I)="F"
1344 IF Z(I)=4 THEN CC$(I)="Na2O"
1345 IF Z(I)=5 THEN CC$(I)="MgO"
1346 IF Z(I)=6 THEN CC$(I)="Al2O3"
1347 IF Z(I)=7 THEN CC$(I)="SiO2"
1348 IF Z(I)=8 THEN CC$(I)="P2O5"
1349 IF Z(I)=9 THEN CC$(I)="SO3"
1350 IF Z(I)=10 THEN CC$(I)="Cl"
1351 IF Z(I)=11 THEN CC$(I)="K2O"
1352 IF Z(I)=12 THEN CC$(I)="CaO"
1353 IF Z(I)=13 THEN CC$(I)="TiO2"
1354 IF Z(I)=14 THEN CC$(I)="Cr2O3"
1355 IF Z(I)=15 THEN CC$(I)="MnO"
1356 IF Z(I)=16 THEN CC$(I)="FeO"
1357 IF Z(I)=17 THEN CC$(I)="CoO"
1358 IF Z(I)=18 THEN CC$(I)="NiO"
1359 IF Z(I)=19 THEN CC$(I)="CuO"
1360 IF Z(I)=20 THEN CC$(I)="ZnO"
1361 IF Z(I)=21 THEN CC$(I)="Rb2O"
1362 IF Z(I)=22 THEN CC$(I)="SrO"
1363 IF Z(I)=23 THEN CC$(I)="Y2O3"
1364 IF Z(I)=24 THEN CC$(I)="ZrO2"
1365 IF Z(I)=25 THEN CC$(I)="BaO"
1366 IF Z(I)=26 THEN CC$(I)="La2O3"
1367 IF Z(I)=27 THEN CC$(I)="Ce2O3"
1368 IF Z(I)=28 THEN CC$(I)="Pr2O3"
1369 IF Z(I)=29 THEN CC$(I)="Nd2O3"
1370 IF Z(I)=30 THEN CC$(I)="Sm2O3"
1371 IF Z(I)=31 THEN CC$(I)="Gd2O3"
1372 IF Z(I)=32 THEN CC$(I)="Dy2O3"
1373 IF Z(I)=33 THEN CC$(I)="Er2O3"
1374 IF Z(I)=34 THEN CC$(I)="HfO2"
1375 IF Z(I)=35 THEN CC$(I)="ThO2"
1376 IF Z(I)=36 THEN CC$(I)="UO2"
1377 NEXT I
1380 IF XX$="y" OR XX$="Y" GOTO 1400 ELSE 1500
1400 FOR I=1 TO AA
1410 LOCATE (4+I),14:PRINT"";CC$(I);TAB(33);
1420 PRINT USING"#.###";A5(I)/A6(I);
1430 PRINT TAB(55);
1440 PRINT USING"###.###";K(I)*100
1450 NEXT I
1460 PRINT
1470 PRINT TAB(14)"Total:";TAB(55);
1480 PRINT USING"###.###";S1*100
1490 GOTO 1600
1500 'Results for mix.std.
1510 FOR I=1 TO AA
1520 LOCATE(4+I),14:PRINT"";CC$(I);TAB(33);
1530 PRINT USING"#.###";A5(I)/A6(I)*W1(I)/B1(I);
1540 PRINT TAB(55);
1550 PRINT USING"###.###";K(I)*100
1560 NEXT I
1570 PRINT
1580 PRINT TAB(14)"Total:";TAB(55);
1590 PRINT USING"###.###";S1*100
1600 LOCATE 24,32:INPUT"Hard copy (y/n): ",HH$
1610 IF HH$="Y" OR HH$="y" GOTO 1700 ELSE 1990
1700 'Printer
1710 CLS
1740 LOCATE 13,23:INPUT"Please type sample name: ",SX$
1750 LPRINT:LPRINT:LPRINT:LPRINT
1760 LPRINT CHR$(27)+"G";
1770 LPRINT TAB(25)"BENCE-ALBEE CORRECTION PROGRAM"
1780 LPRINT CHR$(27)+"H";
1790 LPRINT:LPRINT
1800 LPRINT TAB(30)"  Date: ";DATE$
1810 LPRINT TAB(30)"  Time: ";TIME$
1820 LPRINT TAB(30)"Sample: ";SX$
1830 LPRINT:LPRINT
1840 LPRINT TAB(16)"Accelerating voltage: 20 keV"
1850 LPRINT TAB(16)"      Take-off angle: 38.5 degrees"
1880 LPRINT:LPRINT
1885 LPRINT TAB(14)"Oxide";TAB(32)"K-ratio";TAB(52)"Weight percent"
1887 LPRINT
1890 IF XX$="Y" OR XX$="y" GOTO 1900 ELSE 1950
1900 FOR I=1 TO AA
1905 LPRINT TAB(14)"";CC$(I);TAB(33);
1906 LPRINT USING"#.###";A5(I)/A6(I);
1907 LPRINT TAB(55);
1908 LPRINT USING"###.###";K(I)*100
1910 NEXT I
1920 LPRINT
1930 LPRINT TAB(14)"Total:";TAB(55);
1940 LPRINT USING"###.###";S1*100
1945 GOTO 1990
1950 FOR I=1 TO AA
1955 LPRINT TAB(14)"";CC$(I);TAB(33);
1956 LPRINT USING"#.###";A5(I)/A6(I)*W1(I)/B1(I);
1957 LPRINT TAB(55);
1958 LPRINT USING"###.###";K(I)*100
1959 NEXT I
1960 LPRINT
1970 LPRINT TAB(14)"Total:";TAB(55);
1980 LPRINT USING"###.###";S1*100
1990 CLS
1991 LOCATE 13,27:INPUT"Another calculation (y/n): ",DDD$
1992 IF DDD$="y" OR DDD$="Y" GOTO 305 ELSE 2000
2000 CLS:CLOSE
2010 OPEN"i",#5,"menu.dat"
2020 INPUT #5,XY999
2030 IF XY99=1 GOTO 2050
2040 IF XY99=0 GOTO 2060
2050 CLS:CLOSE:RUN"ms8.exe":END
2060 CLS:CLOSE:SYSTEM:END
