300 'Bence-Albee program for 20 kV-52.5 degrees
305 CLEAR
310 KEY OFF
320 OPEN"i",#1,"color.dat"
330 INPUT #1,X999
340 INPUT #1,Y999
350 INPUT #1,Z999
360 COLOR X999,Y999,Z999
370 CLS
380 DIM A(36,36),Z$(15),Z(15),A5(15),BCU(15),A6(15),BCS(15),W1(15),B1(15)
390 DIM K0(15),K(15),CC$(15),B(36,36)
410 ' Bence-Albee program for 15 kV - 38.5 degrees
420 CLS
430 T$="BENCE-ALBEE CORRECTION PROGRAM"
440 LOCATE 5,(80-LEN(T$))/2
450 PRINT T$
460 LOCATE 10,30:INPUT"Number of elements: ",AA
470 LOCATE 12,22:INPUT"Pure oxide standards (y/n): ",XX$
475 CLS
480 LOCATE 3,6:PRINT"Element";TAB(19)"Int.for sample";TAB(39)"BCF";TAB(47)"Int.for standard";TAB(68)"BCF"
490 FOR I=1 TO AA
500 LOCATE (4+I),8:INPUT"",Z$(I)
501 IF Z$(I)="O" OR Z$(I)="o" THEN Z(I)=1
502 IF Z$(I)="C" OR Z$(I)="c" THEN Z(I)=2
503 IF Z$(I)="F" OR Z$(I)="f" THEN Z(I)=3
504 IF Z$(I)="Na" OR Z$(I)="na" OR Z$(I)="NA" THEN Z(I)=4
505 IF Z$(I)="Al" OR Z$(I)="al" OR Z$(I)="AL" THEN Z(I)=6
506 IF Z$(I)="Mg" OR Z$(I)="mg" OR Z$(I)="MG" THEN Z(I)=5
507 IF Z$(I)="Si"OR Z$(I)="si" OR Z$(I)="SI" THEN Z(I)=7
508 IF Z$(I)="P" OR Z$(I)="p" THEN Z(I)=8
509 IF Z$(I)="S" OR Z$(I)="s" THEN Z(I)=9
510 IF Z$(I)="Cl" OR Z$(I)="cl" OR Z$(I)="CL" THEN Z(I)=10
511 IF Z$(I)="K" OR Z$(I)="k" THEN Z(I)=11
512 IF Z$(I)="Ca" OR Z$(I)="ca" OR Z$(I)="CA" THEN Z(I)=12
513 IF Z$(I)="Ti" OR Z$(I)="ti" OR Z$(I)="TI" THEN Z(I)=13
514 IF Z$(I)="Cr" OR Z$(I)="cr" OR Z$(I)="CR" THEN Z(I)=14
515 IF Z$(I)="Mn" OR Z$(I)="mn" OR Z$(I)="MN" THEN Z(I)=15
516 IF Z$(I)="Fe" OR Z$(I)="fe" OR Z$(I)="FE" THEN Z(I)=16
517 IF Z$(I)="Co" OR Z$(I)="co" OR Z$(I)="CO" THEN Z(I)=17
518 IF Z$(I)="Ni" OR Z$(I)="ni" OR Z$(I)="NI" THEN Z(I)=18
519 IF Z$(I)="Cu" OR Z$(I)="cu" OR Z$(I)="CU" THEN Z(I)=19
520 IF Z$(I)="Zn" OR Z$(I)="zn" OR Z$(I)="ZN" THEN Z(I)=20
521 IF Z$(I)="Rb" OR Z$(I)="rb" OR Z$(I)="RB" THEN Z(I)=21
522 IF Z$(I)="Sr" OR Z$(I)="sr" OR Z$(I)="SR" THEN Z(I)=22
523 IF Z$(I)="Y" OR Z$(I)="y" THEN Z(I)=23
524 IF Z$(I)="Zr" OR Z$(I)="zr" OR Z$(I)="ZR" THEN Z(I)=24
525 IF Z$(I)="La" OR Z$(I)="la" OR Z$(I)="LA" THEN Z(I)=26
526 IF Z$(I)="Ce" OR Z$(I)="ce" OR Z$(I)="CE" THEN Z(I)=27
527 IF Z$(I)="Pr" OR Z$(I)="pr" OR Z$(I)="PR" THEN Z(I)=28
528 IF Z$(I)="Nd" OR Z$(I)="nd" OR Z$(I)="ND" THEN Z(I)=29
529 IF Z$(I)="Sm" OR Z$(I)="sm" OR Z$(I)="SM" THEN Z(I)=30
530 IF Z$(I)="Gd" OR Z$(I)="gd" OR Z$(I)="GD" THEN Z(I)=31
531 IF Z$(I)="Dy" OR Z$(I)="dy" OR Z$(I)="DY" THEN Z(I)=32
532 IF Z$(I)="Er" OR Z$(I)="er" OR Z$(I)="ER" THEN Z(I)=33
533 IF Z$(I)="Hf" OR Z$(I)="hf" OR Z$(I)="HF" THEN Z(I)=34
534 IF Z$(I)="Th" OR Z$(I)="th" OR Z$(I)="TH" THEN Z(I)=35
535 IF Z$(I)="U" OR Z$(I)="u" THEN Z(I)=36
536 IF Z$(I)="Ba" OR Z$(I)="ba" OR Z$(I)="BA" THEN Z(I)=25
540 LOCATE (4+I),21:INPUT"",A5(I)
550 LOCATE (4+I),39:INPUT"",BCU(I)
560 LOCATE (4+I),49:INPUT"",A6(I)
570 LOCATE (4+I),68:INPUT"",BCS(I)
580 NEXT I
590 IF XX$="N" OR XX$="n" THEN 600 ELSE 700
600 CLS
610 T$="Input data for mixed (not pure oxid) standards."
620 LOCATE 3,(80-LEN(T$))/2
630 PRINT T$
640 LOCATE 5,14:PRINT"Element";TAB(34)"Weight percent";TAB(60)"Beta"
650 FOR I=1 TO AA
660 LOCATE (6+I),17:PRINT Z$(I)
670 LOCATE (6+I),37:INPUT"",W1(I):W1(I)=W1(I)/100
680 LOCATE (6+I),60:INPUT"",B1(I)
690 NEXT I
700 ' izracun po metodi Bence-Albee
710 ' izracun prve aproksimacije sestave vzorca v uteznih oksidih
720 IF XX$="y" OR XX$="Y" THEN 725 ELSE 800
725 S=0
730 FOR I=1 TO AA
740 A5(I)=A5(I)*(1/BCU(I))
750 A6(I)=A6(I)*(1/BCS(I))
760 K0(I)=A5(I)/A6(I)
770 S=S+K0(I)
780 NEXT I
785 GOTO 900
790 ' izracun prve sestave za primere mesanih standardov
800 S=0
810 FOR I=1 TO AA
820 A5(I)=A5(I)*(1/BCU(I))
830 A6(I)=A6(I)*(1/BCS(I))
840 K0(I)=A5(I)/A6(I)*W1(I)/B1(I)
850 S=S+K0(I)
860 NEXT I
900 'izracun
1000 ' alfa matrika za 20 kV-52.5 stopinj
1020 DATA 1.00,2.17,1.09,1.59,2.01,2.26,2.57,2.96,3.34,9.30,12.62,13.43,16.01,2.08,2.42,2.70,2.95,3.35,3.68,4.12,9.56,10.50,10.9,11.78,3.74,3.77,3.94,4.12,4.26,4.57,4.96,5.29,5.62,6.60,12.71,14.03
1021 DATA 1.18,1.00,1.55,3.42,4.92,6.47,7.62,10.32,11.89,47.06,3.99,3.78,3.88,5.44,6.97,8.19,9.55,11.35,13.46,15.97,34.02,27.54,21.99,24.40,10.45,10.04,10.65,11.30,11.92,13.21,14.92,16.35,17.80,23.25,55.01,62.26
1022 DATA 8.97,8.26,1.00,3.02,4.43,5.48,6.23,7.05,7.61,4.68,7.62,9.20,12.17,15.24,17.22,3.21,3.27,3.52,3.57,3.77,5.57,6.52,7.22,8.10,3.05,3.31,3.41,3.52,3.58,3.71,3.88,4.03,4.19,4.89,7.86,8.51
1023 DATA 1.98,1.76,2.32,1.00,1.26,1.38,1.51,1.59,1.69,1.30,1.73,1.97,2.29,2.81,3.18,3.56,3.96,4.46,4.18,3.33,1.46,1.61,1.69,1.83,2.63,2.67,2.90,3.06,3.20,1.19,1.22,1.26,1.29,1.45,2.13,2.28
1024 DATA 1.44,1.29,1.62,2.27,1.00,1.06,1.15,1.18,1.24,1.00,1.25,1.40,1.56,1.82,2.03,2.24,2.45,2.72,2.94,3.23,1.06,1.15,1.20,1.28,2.31,2.34,2.08,2.19,2.00,2.16,2.33,0.96,0.98,1.06,1.47,1.55
1025 DATA 1.24,1.14,1.35,1.75,1.92,1.00,1.05,1.07,1.11,0.94,1.12,1.22,1.31,1.48,1.62,1.76,1.89,2.07,2.20,2.38,0.97,1.04,1.07,1.13,2.12,2.11,2.21,2.05,2.13,1.97,1.86,1.99,2.13,0.99,1.33,1.40
1026 DATA 1.12,1.05,1.18,1.46,1.58,1.67,1.00,1.00,1.03,0.90,1.02,1.10,1.15,1.25,1.34,1.43,1.51,1.64,1.70,1.82,0.89,0.94,0.96,1.00,1.61,1.61,1.68,1.75,1.81,1.93,1.83,1.68,1.60,1.86,1.11,1.16
1027 DATA 1.09,1.03,1.12,1.31,1.40,1.46,1.53,1.00,1.02,0.91,1.00,1.06,1.08,1.16,1.21,1.28,1.33,1.43,1.47,1.55,2.10,2.19,0.94,0.97,1.43,1.42,1.47,1.53,1.57,1.66,1.75,1.67,1.77,1.61,1.08,1.12
1028 DATA 1.04,1.00,1.05,1.20,1.27,1.30,1.36,1.40,1.00,0.89,0.96,1.01,1.02,1.07,1.10,1.15,1.18,1.25,1.26,1.32,1.84,1.92,1.73,1.80,1.19,1.19,1.23,1.27,1.29,1.35,1.40,1.47,1.54,1.41,0.95,0.98
1029 DATA 1.12,1.08,1.11,1.23,1.29,1.31,1.36,1.39,1.43,1.00,1.03,1.08,1.07,1.10,1.11,1.15,1.17,1.23,1.22,1.26,1.61,1.66,1.69,1.73,1.12,1.14,1.17,1.20,1.22,1.25,1.28,1.33,1.38,1.51,0.94,0.96
1030 DATA 1.06,1.04,1.04,1.10,1.15,1.15,1.18,1.18,1.21,1.44,1.00,1.00,0.98,0.99,0.99,1.01,1.02,1.06,1.04,1.06,1.23,1.26,1.27,1.30,0.95,0.96,0.98,0.99,1.00,1.02,1.03,1.05,1.08,1.15,0.85,0.87
1031 DATA 1.03,1.01,1.00,1.05,1.09,1.09,1.12,1.12,1.14,1.29,1.35,1.00,0.93,0.94,0.93,0.96,0.95,0.99,0.97,0.99,1.10,1.12,1.13,1.16,0.86,0.88,0.89,0.91,0.91,0.92,0.93,0.94,0.96,1.01,1.11,0.91
1032 DATA 1.07,1.05,1.04,1.08,1.11,1.11,1.13,1.12,1.13,1.19,1.23,1.26,1.00,0.92,0.91,0.94,0.94,0.97,0.95,0.96,1.03,1.05,1.06,1.07,0.88,0.87,0.88,0.85,0.86,0.86,0.87,0.88,0.89,0.92,1.03,1.06
1033 DATA 1.09,1.07,1.05,1.08,1.12,1.10,1.12,1.11,1.12,1.13,1.16,1.18,1.14,1.00,0.95,0.90,0.90,0.93,0.91,0.92,0.98,0.99,1.00,1.01,1.01,0.88,0.88,0.89,0.89,0.85,0.80,0.81,0.82,0.85,1.02,1.01
1034 DATA 1.12,1.11,1.08,1.11,1.14,1.13,1.15,1.13,1.14,1.13,1.16,1.18,1.14,1.03,1.00,0.99,0.89,0.92,0.90,0.92,0.97,0.99,1.00,1.01,1.03,1.05,1.00,0.90,0.89,0.89,0.84,0.84,0.79,0.82,0.96,0.99
1035 DATA 1.11,1.09,1.07,1.10,1.13,1.12,1.13,1.11,1.13,1.10,1.13,1.15,1.11,1.13,0.99,1.00,0.95,0.88,0.86,0.88,0.95,0.96,0.98,0.99,1.01,1.02,1.01,0.97,0.97,0.87,0.85,0.81,0.81,0.78,0.91,0.93
1036 DATA 1.14,1.12,1.09,1.12,1.15,1.14,1.15,1.13,1.14,1.11,1.13,1.16,1.11,1.12,1.11,1.02,1.00,0.99,0.84,0.86,0.95,0.97,0.98,0.99,0.99,1.00,1.01,1.03,1.00,0.95,0.86,0.85,0.80,0.75,0.90,0.91
1037 DATA 1.11,1.09,1.07,1.09,1.12,1.11,1.12,1.10,1.11,1.08,1.09,1.12,1.07,1.08,1.06,1.08,0.98,1.00,0.92,0.80,0.92,0.94,0.95,0.96,0.94,0.95,0.96,0.97,0.97,0.94,0.90,0.83,0.82,0.78,0.85,0.86
1038 DATA 1.16,1.14,1.12,1.14,1.17,1.15,1.17,1.15,1.16,1.11,1.13,1.16,1.11,1.11,1.09,1.11,1.10,1.04,1.00,0.95,0.95,0.97,0.98,0.99,0.95,0.97,0.97,0.98,0.98,0.98,0.95,0.91,0.85,0.78,0.86,0.88
1039 DATA 1.17,1.15,1.12,1.14,1.17,1.16,1.17,1.15,1.16,1.11,1.13,1.15,1.10,1.10,1.08,1.10,1.08,1.12,1.00,1.00,0.95,0.97,0.98,0.99,0.94,0.95,0.96,0.97,0.96,0.96,0.94,0.92,0.89,0.84,0.85,0.86
1040 DATA 1.36,1.28,1.38,1.64,1.76,1.86,1.21,1.19,1.24,1.07,1.19,1.28,1.31,1.42,1.47,1.56,1.63,1.76,1.81,1.92,1.00,1.04,1.08,1.12,1.73,1.79,1.87,1.95,2.01,1.92,2.04,1.89,1.80,1.23,1.23,1.28
1041 DATA 1.29,1.21,1.31,1.54,1.65,1.73,1.16,1.14,1.18,1.03,1.14,1.22,1.24,1.33,1.38,1.46,1.52,1.63,1.68,1.77,1.93,1.00,1.04,1.07,1.57,1.63,1.69,1.76,1.81,1.93,1.83,1.70,1.62,1.81,1.14,1.19
1042 DATA 1.24,1.18,1.25,1.44,1.53,1.59,1.66,1.11,1.15,1.01,1.10,1.17,1.18,1.25,1.29,1.36,1.41,1.51,1.54,1.62,2.18,0.96,1.00,1.02,1.46,1.50,1.56,1.62,1.66,1.76,1.86,1.77,1.65,1.67,1.10,1.14
1043 DATA 1.20,1.14,1.21,1.38,1.46,1.51,1.58,1.09,1.12,0.99,1.07,1.14,1.14,1.20,1.23,1.30,1.34,1.43,1.45,1.52,1.99,2.04,0.98,1.00,1.36,1.40,1.44,1.50,1.53,1.61,1.69,1.61,1.70,1.52,1.05,1.08
1044 DATA 1.37,1.33,1.31,1.33,1.39,1.35,1.39,1.35,1.38,1.41,1.45,1.49,1.21,1.16,1.14,1.16,1.15,1.19,1.14,1.15,1.18,1.19,1.22,1.23,1.00,1.03,1.02,1.04,1.03,1.01,1.00,1.01,1.02,1.04,1.15,1.19
1045 DATA 1.34,1.31,1.28,1.31,1.36,1.33,1.36,1.33,1.35,1.36,1.40,1.43,1.19,1.16,1.11,1.13,1.12,1.16,1.11,1.12,1.13,1.15,1.18,1.19,0.97,1.00,1.01,1.00,1.00,0.98,0.97,0.98,0.98,1.01,1.11,1.15
1046 DATA 1.33,1.30,1.27,1.30,1.35,1.32,1.35,1.32,1.35,1.34,1.38,1.41,1.19,1.16,1.11,1.13,1.11,1.15,1.10,1.11,1.12,1.14,1.16,1.17,0.97,0.99,1.00,1.01,1.01,0.98,0.96,0.96,0.96,0.98,1.14,1.11
1047 DATA 1.33,1.30,1.27,1.29,1.34,1.31,1.34,1.31,1.33,1.32,1.35,1.39,1.33,1.16,1.12,1.12,1.10,1.13,1.09,1.10,1.10,1.12,1.14,1.15,0.96,0.98,0.99,1.00,1.00,0.97,0.94,0.94,0.94,0.96,1.10,1.08
1048 DATA 1.34,1.31,1.28,1.31,1.36,1.33,1.36,1.32,1.35,1.33,1.35,1.39,1.33,1.17,1.14,1.13,1.10,1.14,1.10,1.10,1.10,1.12,1.14,1.15,0.96,0.99,1.00,1.01,1.00,0.99,0.97,0.94,0.94,0.96,1.13,1.12
1049 DATA 1.37,1.34,1.31,1.33,1.38,1.35,1.38,1.34,1.37,1.33,1.36,1.39,1.33,1.20,1.17,1.18,1.12,1.16,1.11,1.11,1.10,1.12,1.14,1.16,1.16,1.12,1.01,1.02,1.01,1.00,0.99,0.96,0.94,0.95,1.09,1.12
1050 DATA 1.41,1.38,1.35,1.37,1.42,1.38,1.42,1.37,1.40,1.35,1.37,1.41,1.35,1.36,1.20,1.22,1.18,1.18,1.13,1.13,1.12,1.13,1.16,1.17,1.18,1.17,1.13,1.14,1.03,1.02,1.00,0.97,0.97,0.95,1.07,1.10
1051 DATA 1.44,1.41,1.37,1.39,1.44,1.41,1.44,1.40,1.42,1.36,1.38,1.42,1.35,1.36,1.22,1.24,1.21,1.24,1.14,1.14,1.12,1.14,1.16,1.18,1.16,1.19,1.17,1.18,1.13,1.03,1.01,1.00,0.97,0.94,1.05,1.07
1052 DATA 1.46,1.43,1.39,1.41,1.46,1.43,1.46,1.41,1.44,1.37,1.39,1.43,1.36,1.36,1.34,1.25,1.23,1.26,1.20,1.15,1.13,1.15,1.17,1.18,1.14,1.17,1.18,1.19,1.17,1.11,1.02,1.01,1.00,0.97,1.04,1.05
1053 DATA 1.47,1.44,1.41,1.42,1.47,1.43,1.46,1.42,1.45,1.37,1.39,1.43,1.36,1.34,1.32,1.34,1.33,1.28,1.22,1.20,1.13,1.16,1.18,1.19,1.12,1.14,1.15,1.16,1.16,1.15,1.09,1.08,1.01,1.00,1.01,1.03
1054 DATA 1.56,1.49,1.49,1.53,1.61,1.57,1.63,1.59,1.65,1.86,1.34,1.41,1.34,1.32,1.32,1.35,1.34,1.40,1.35,1.38,1.53,1.56,1.61,1.63,1.16,1.20,1.22,1.24,1.25,1.27,1.29,1.32,1.35,1.42,1.00,1.02
1055 DATA 1.56,1.50,1.49,1.52,1.60,1.55,1.61,1.56,1.62,1.79,1.34,1.42,1.34,1.31,1.31,1.34,1.32,1.38,1.33,1.35,1.47,1.49,1.53,1.56,1.13,1.17,1.19,1.21,1.21,1.23,1.24,1.26,1.29,1.35,0.98,1.00
1060 FOR X=1 TO 36
1070 FOR Y=1 TO 36
1080 READ A(X,Y)
1090 NEXT Y
1100 NEXT X
1110 'izracun koncentracije uteznih oksidov
1120 S1=0:B(I,J)=0
1130 FOR I=1 TO AA
1140 B=0
1150 FOR J=1 TO AA
1160 B(I,J)=K0(J)*A(Z(I),Z(J))
1170 B=B+B(I,J)
1180 NEXT J
1190 K(I)=K0(I)*(B/S)
1200 S1=S1+K(I)
1210 NEXT I
1220 'iterativni pogoj
1230 IF (S1-S)<.00001 GOTO 1300 ELSE 1240
1240 IF S1>1 GOTO 1300 ELSE 1245
1245 S=0:S=S1
1250 FOR I=1 TO AA
1260 K0(I)=0
1270 K0(I)=K(I)
1280 NEXT I
1290 GOTO 1110
1300 'izpis rezultatov na zaslon
1305 CLS
1310 LOCATE 3,10
1320 PRINT TAB(14)"Oxide";TAB(32)"K-ratio";TAB(52)"Weight percent"
1340 FOR I=1 TO AA
1341 IF Z(I)=1 THEN CC$(I)="O"
1342 IF Z(I)=2 THEN CC$(I)="CO2"
1343 IF Z(I)=3 THEN CC$(I)="F"
1344 IF Z(I)=4 THEN CC$(I)="Na2O"
1345 IF Z(I)=5 THEN CC$(I)="MgO"
1346 IF Z(I)=6 THEN CC$(I)="Al2O3"
1347 IF Z(I)=7 THEN CC$(I)="SiO2"
1348 IF Z(I)=8 THEN CC$(I)="P2O5"
1349 IF Z(I)=9 THEN CC$(I)="SO3"
1350 IF Z(I)=10 THEN CC$(I)="Cl"
1351 IF Z(I)=11 THEN CC$(I)="K2O"
1352 IF Z(I)=12 THEN CC$(I)="CaO"
1353 IF Z(I)=13 THEN CC$(I)="TiO2"
1354 IF Z(I)=14 THEN CC$(I)="Cr2O3"
1355 IF Z(I)=15 THEN CC$(I)="MnO"
1356 IF Z(I)=16 THEN CC$(I)="FeO"
1357 IF Z(I)=17 THEN CC$(I)="CoO"
1358 IF Z(I)=18 THEN CC$(I)="NiO"
1359 IF Z(I)=19 THEN CC$(I)="CuO"
1360 IF Z(I)=20 THEN CC$(I)="ZnO"
1361 IF Z(I)=21 THEN CC$(I)="Rb2O"
1362 IF Z(I)=22 THEN CC$(I)="SrO"
1363 IF Z(I)=23 THEN CC$(I)="Y2O3"
1364 IF Z(I)=24 THEN CC$(I)="ZrO2"
1365 IF Z(I)=25 THEN CC$(I)="BaO"
1366 IF Z(I)=26 THEN CC$(I)="La2O3"
1367 IF Z(I)=27 THEN CC$(I)="Ce2O3"
1368 IF Z(I)=28 THEN CC$(I)="Pr2O3"
1369 IF Z(I)=29 THEN CC$(I)="Nd2O3"
1370 IF Z(I)=30 THEN CC$(I)="Sm2O3"
1371 IF Z(I)=31 THEN CC$(I)="Gd2O3"
1372 IF Z(I)=32 THEN CC$(I)="Dy2O3"
1373 IF Z(I)=33 THEN CC$(I)="Er2O3"
1374 IF Z(I)=34 THEN CC$(I)="HfO2"
1375 IF Z(I)=35 THEN CC$(I)="ThO2"
1376 IF Z(I)=36 THEN CC$(I)="UO2"
1377 NEXT I
1380 IF XX$="y" OR XX$="Y" GOTO 1400 ELSE 1500
1400 FOR I=1 TO AA
1410 LOCATE (4+I),14:PRINT"";CC$(I);TAB(33);
1420 PRINT USING"#.###";A5(I)/A6(I);
1430 PRINT TAB(55);
1440 PRINT USING"###.###";K(I)*100
1450 NEXT I
1460 PRINT
1470 PRINT TAB(14)"Total:";TAB(55);
1480 PRINT USING"###.###";S1*100
1490 GOTO 1600
1500 'izpis rezultatov za mesane standarde
1510 FOR I=1 TO AA
1520 LOCATE (4+I),14:PRINT"";CC$(I);TAB(33);
1530 PRINT USING"#.###";A5(I)/A6(I)*W1(I)/B1(I);
1540 PRINT TAB(55);
1550 PRINT USING"###.###";K(I)*100
1560 NEXT I
1570 PRINT
1580 PRINT TAB(14)"Total:";TAB(55);
1590 PRINT USING"###.###";S1*100
1600 LOCATE 24,32:INPUT"Hard copy (y/n): ",HH$
1610 IF HH$="Y" OR HH$="y" GOTO 1700 ELSE 1990
1700 'izpis rezultatov na linijski printer
1710 CLS
1740 LOCATE 13,23:INPUT"Please type sample name: ",SX$
1750 LPRINT:LPRINT:LPRINT:LPRINT
1760 LPRINT CHR$(27)+"G";
1770 LPRINT TAB(25)"BENCE-ALBEE CORRECTION PROGRAM"
1780 LPRINT CHR$(27)+"H";
1790 LPRINT:LPRINT
1800 LPRINT TAB(30)"  Date: ";DATE$
1810 LPRINT TAB(30)"  Time: ";TIME$
1820 LPRINT TAB(30)"Sample: ";SX$
1830 LPRINT:LPRINT
1840 LPRINT TAB(16)"Accelerating voltage: 20 keV"
1850 LPRINT TAB(16)"      Take-off angle: 52.5 degrees"
1880 LPRINT:LPRINT
1885 LPRINT TAB(14)"Oxide";TAB(32)"K-ratio";TAB(52)"Weight percent"
1887 LPRINT
1890 IF XX$="y" OR XX$="Y" GOTO 1900 ELSE 1950
1900 FOR I=1 TO AA
1905 LPRINT TAB(14)"";CC$(I);TAB(33);
1906 LPRINT USING"#.###";A5(I)/A6(I);
1907 LPRINT TAB(55);
1908 LPRINT USING"###.###";K(I)*100
1910 NEXT I
1920 LPRINT
1930 LPRINT TAB(14)"Total:";TAB(55);
1940 LPRINT USING"###.###";S1*100
1945 GOTO 1990
1950 FOR I=1 TO AA
1955 LPRINT TAB(14)"";CC$(I);TAB(33);
1956 LPRINT USING"#.###";A5(I)/A6(I)*W1(I)/B1(I);
1957 LPRINT TAB(55);
1958 LPRINT USING"###.###";K(I)*100
1959 NEXT I
1960 LPRINT
1970 LPRINT TAB(14)"Total:";TAB(55);
1980 LPRINT USING"###.###";S1*100
1990 CLS
1991 LOCATE 13,27:INPUT"Another calculation (y/n): ",DDD$
1992 IF DDD$="y" OR DDD$="Y" GOTO 305 ELSE 2000
2000 CLOSE:CLS
2010 OPEN"i",#5,"menu.dat"
2020 INPUT #5,XY999
2030 IF XY999=1 GOTO 2050
2040 IF XY999=0 GOTO 2060
2050 CLOSE:RUN"ms8.exe":END
2060 CLOSE:SYSTEM:END
